// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

/**
 ** \file /builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.h
 ** Define the hilti::detail::parser::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

#ifndef YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_6_0_3_BUILD_AUXIL_SPICY_HILTI_SRC_AUTOGEN_PARSER_H_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_6_0_3_BUILD_AUXIL_SPICY_HILTI_SRC_AUTOGEN_PARSER_H_INCLUDED


# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>
# include "stack.hh"
# include "location.hh"

#ifndef YYASSERT
# include <cassert>
# define YYASSERT assert
#endif


#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

#line 27 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:377
namespace hilti { namespace detail { namespace parser {
#line 119 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.h" // lalr1.cc:377



  /// A char[S] buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current state.
  template <size_t S>
  struct variant
  {
    /// Type of *this.
    typedef variant<S> self_type;

    /// Empty construction.
    variant ()
    {}

    /// Construct and fill.
    template <typename T>
    variant (const T& t)
    {
      YYASSERT (sizeof (T) <= S);
      new (yyas_<T> ()) T (t);
    }

    /// Destruction, allowed only if empty.
    ~variant ()
    {}

    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    build ()
    {
      return *new (yyas_<T> ()) T;
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    build (const T& t)
    {
      return *new (yyas_<T> ()) T (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as ()
    {
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const
    {
      return *yyas_<T> ();
    }

    /// Swap the content with \a other, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsability.
    /// Swapping between built and (possibly) non-built is done with
    /// variant::move ().
    template <typename T>
    void
    swap (self_type& other)
    {
      std::swap (as<T> (), other.as<T> ());
    }

    /// Move the content of \a other to this.
    ///
    /// Destroys \a other.
    template <typename T>
    void
    move (self_type& other)
    {
      build<T> ();
      swap<T> (other);
      other.destroy<T> ();
    }

    /// Copy the content of \a other to this.
    template <typename T>
    void
    copy (const self_type& other)
    {
      build<T> (other.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
    }

  private:
    /// Prohibit blind copies.
    self_type& operator=(const self_type&);
    variant (const self_type&);

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ ()
    {
      void *yyp = yybuffer_.yyraw;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const
    {
      const void *yyp = yybuffer_.yyraw;
      return static_cast<const T*> (yyp);
     }

    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me;
      /// A buffer large enough to store any of the semantic values.
      char yyraw[S];
    } yybuffer_;
  };


  /// A Bison parser.
  class Parser
  {
  public:
#ifndef YYSTYPE
    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // "bool value"
      char dummy1[sizeof(bool)];

      // "real value"
      char dummy2[sizeof(double)];

      // attribute
      char dummy3[sizeof(hilti::Attribute)];

      // ctor
      // tuple
      // list
      // set
      // map
      // struct_
      // regexp
      char dummy4[sizeof(hilti::Ctor)];

      // global_scope_decl
      // type_decl
      // constant_decl
      // local_decl
      // local_init_decl
      // global_decl
      // function_decl
      // import_decl
      // property_decl
      // struct_field
      // union_field
      char dummy5[sizeof(hilti::Declaration)];

      // expr
      // expr_0
      // expr_1
      // expr_2
      // expr_3
      // expr_4
      // expr_5
      // expr_6
      // expr_7
      // expr_8
      // expr_9
      // expr_a
      // expr_b
      // expr_c
      // expr_d
      // expr_e
      // expr_f
      // expr_g
      // member_expr
      // ctor_expr
      // tuple_elem
      // tuple_expr
      char dummy6[sizeof(hilti::Expression)];

      // function_with_body
      // method_with_body
      // hook_with_body
      // function_without_body
      char dummy7[sizeof(hilti::Function)];

      // local_id
      // scoped_id
      // dotted_id
      // function_id
      // scoped_function_id
      char dummy8[sizeof(hilti::ID)];

      // block
      // braced_block
      // stmt
      // stmt_decl
      // stmt_expr
      char dummy9[sizeof(hilti::Statement)];

      // base_type_no_attrs
      // base_type
      // type
      // function_type
      // tuple_type
      // struct_type
      // union_type
      // enum_type
      char dummy10[sizeof(hilti::Type)];

      // map_elem
      char dummy11[sizeof(hilti::ctor::map::Element)];

      // struct_elem
      char dummy12[sizeof(hilti::ctor::struct_::Field)];

      // opt_linkage
      char dummy13[sizeof(hilti::declaration::Linkage)];

      // opt_func_param_kind
      char dummy14[sizeof(hilti::declaration::parameter::Kind)];

      // opt_func_cc
      char dummy15[sizeof(hilti::function::CallingConvention)];

      // switch_case
      char dummy16[sizeof(hilti::statement::switch_::Case)];

      // try_catch
      char dummy17[sizeof(hilti::statement::try_::Catch)];

      // opt_type_flags
      char dummy18[sizeof(hilti::type::Flags)];

      // enum_label
      char dummy19[sizeof(hilti::type::enum_::Label)];

      // opt_func_flavor
      // func_flavor
      char dummy20[sizeof(hilti::type::function::Flavor)];

      // func_param
      char dummy21[sizeof(hilti::type::function::Parameter)];

      // func_result
      char dummy22[sizeof(hilti::type::function::Result)];

      // tuple_type_elem
      char dummy23[sizeof(hilti::type::tuple::Element)];

      // opt_attributes
      char dummy24[sizeof(std::optional<hilti::AttributeSet>)];

      // opt_func_default_expr
      char dummy25[sizeof(std::optional<hilti::Expression>)];

      // opt_else_block
      char dummy26[sizeof(std::optional<hilti::Statement>)];

      // global_scope_items
      char dummy27[sizeof(std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>>)];

      // "identifier"
      // "scoped identifier"
      // "scoped ~finally"
      // "dotted identifier"
      // "attribute"
      // "property"
      // "string value"
      // "bytes value"
      // "regular expression value"
      // "address value"
      // "port value"
      // re_pattern_constant
      char dummy28[sizeof(std::string)];

      // struct_fields
      // opt_union_fields
      // union_fields
      char dummy29[sizeof(std::vector<hilti::Declaration>)];

      // opt_type_arguments
      // opt_exprs
      // exprs
      // opt_tuple_elems1
      // opt_tuple_elems2
      char dummy30[sizeof(std::vector<hilti::Expression>)];

      // opt_stmts
      // stmts
      char dummy31[sizeof(std::vector<hilti::Statement>)];

      // opt_map_elems
      // map_elems
      char dummy32[sizeof(std::vector<hilti::ctor::map::Element>)];

      // struct_elems
      char dummy33[sizeof(std::vector<hilti::ctor::struct_::Field>)];

      // opt_switch_cases
      // switch_cases
      char dummy34[sizeof(std::vector<hilti::statement::switch_::Case>)];

      // try_catches
      char dummy35[sizeof(std::vector<hilti::statement::try_::Catch>)];

      // enum_labels
      char dummy36[sizeof(std::vector<hilti::type::enum_::Label>)];

      // opt_func_params
      // func_params
      // opt_struct_params
      char dummy37[sizeof(std::vector<hilti::type::function::Parameter>)];

      // tuple_type_elems
      char dummy38[sizeof(std::vector<hilti::type::tuple::Element>)];

      // re_patterns
      char dummy39[sizeof(std::vector<std::string>)];

      // "unsigned integer value"
      char dummy40[sizeof(uint64_t)];
};

    /// Symbol semantic values.
    typedef variant<sizeof(union_type)> semantic_type;
#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m);
      location_type location;
    };

    /// Tokens.
    struct token
    {
      enum yytokentype
      {
        EOD = 0,
        IDENT = 258,
        SCOPED_IDENT = 259,
        SCOPED_FINALIZE = 260,
        DOTTED_IDENT = 261,
        ATTRIBUTE = 262,
        PROPERTY = 263,
        CSTRING = 264,
        CBYTES = 265,
        CREGEXP = 266,
        CADDRESS = 267,
        CPORT = 268,
        CUREAL = 269,
        CUINTEGER = 270,
        CBOOL = 271,
        ADD = 272,
        ASSERT = 273,
        ASSERT_EXCEPTION = 274,
        ADDRESS = 275,
        AFTER = 276,
        AND = 277,
        ANY = 278,
        ARROW = 279,
        AUTO = 280,
        AT = 281,
        BEGIN_ = 282,
        BOOL = 283,
        BREAK = 284,
        BYTES = 285,
        CADDR = 286,
        CALLABLE = 287,
        CASE = 288,
        CAST = 289,
        CATCH = 290,
        CHANNEL = 291,
        CLASSIFIER = 292,
        CNULL = 293,
        CONST = 294,
        CONTINUE = 295,
        CONTEXT = 296,
        COPY = 297,
        DECLARE = 298,
        DEFAULT = 299,
        DELETE = 300,
        DIVIDEASSIGN = 301,
        DOLLARDOLLAR = 302,
        DOTDOT = 303,
        REAL = 304,
        ELSE = 305,
        END_ = 306,
        ENUM = 307,
        EQ = 308,
        ERROR = 309,
        EXCEPTION = 310,
        EXPORT = 311,
        EXTERN = 312,
        EXTERN_NO_SUSPEND = 313,
        FILE = 314,
        FINALIZE = 315,
        FOR = 316,
        FROM = 317,
        FUNCTION = 318,
        GEQ = 319,
        GLOBAL = 320,
        HASATTR = 321,
        HOOK = 322,
        IF = 323,
        IMPORT = 324,
        IN = 325,
        INIT = 326,
        INOUT = 327,
        INT = 328,
        INT16 = 329,
        INT32 = 330,
        INT64 = 331,
        INT8 = 332,
        INTERVAL = 333,
        INTERVAL_NS = 334,
        IOSRC = 335,
        ITERATOR = 336,
        CONST_ITERATOR = 337,
        LEQ = 338,
        LIBRARY_TYPE = 339,
        LIST = 340,
        LOCAL = 341,
        MAP = 342,
        MATCH_TOKEN_STATE = 343,
        METHOD = 344,
        MINUSASSIGN = 345,
        MINUSMINUS = 346,
        MOD = 347,
        MODULE = 348,
        MOVE = 349,
        NEW = 350,
        NEQ = 351,
        NETWORK = 352,
        NOT_IN = 353,
        OPTIONAL = 354,
        OR = 355,
        OVERLAY = 356,
        PACK = 357,
        PLUSASSIGN = 358,
        PLUSPLUS = 359,
        PORT = 360,
        POW = 361,
        PREINIT = 362,
        PRIVATE = 363,
        PUBLIC = 364,
        STRONG_REF = 365,
        REGEXP = 366,
        RESULT = 367,
        RETURN = 368,
        SCOPE = 369,
        SET = 370,
        SHIFTLEFT = 371,
        SHIFTRIGHT = 372,
        STREAM = 373,
        STRING = 374,
        STRUCT = 375,
        SWITCH = 376,
        TIME = 377,
        TIME_NS = 378,
        TIMER = 379,
        TIMERMGR = 380,
        TIMESASSIGN = 381,
        THROW = 382,
        TRY = 383,
        TRYATTR = 384,
        TUPLE = 385,
        TYPE = 386,
        TYPEINFO = 387,
        UINT = 388,
        UINT16 = 389,
        UINT32 = 390,
        UINT64 = 391,
        UINT8 = 392,
        UNION = 393,
        UNPACK = 394,
        UNSET = 395,
        VECTOR = 396,
        VIEW = 397,
        VOID = 398,
        WHILE = 399,
        WITH = 400,
        VALUE_REF = 401,
        WEAK_REF = 402,
        YIELD = 403
      };
    };

    /// (External) token type, as returned by yylex.
    typedef token::yytokentype token_type;

    /// Symbol type: an internal symbol number.
    typedef int symbol_number_type;

    /// The symbol type number to denote an empty symbol.
    enum { empty_symbol = -2 };

    /// Internal symbol number for tokens (subsumed by symbol_number_type).
    typedef unsigned char token_number_type;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol type
    /// via type_get().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ();

      /// Copy constructor.
      basic_symbol (const basic_symbol& other);

      /// Constructor for valueless symbols, and symbols from each type.

  basic_symbol (typename Base::kind_type t, const location_type& l);

  basic_symbol (typename Base::kind_type t, const bool v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const double v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::Attribute v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::Ctor v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::Declaration v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::Expression v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::Function v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::ID v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::Statement v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::Type v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::ctor::map::Element v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::ctor::struct_::Field v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::declaration::Linkage v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::declaration::parameter::Kind v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::function::CallingConvention v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::statement::switch_::Case v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::statement::try_::Catch v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::type::Flags v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::type::enum_::Label v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::type::function::Flavor v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::type::function::Parameter v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::type::function::Result v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const hilti::type::tuple::Element v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::optional<hilti::AttributeSet> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::optional<hilti::Expression> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::optional<hilti::Statement> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::string v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::Declaration> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::Expression> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::Statement> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::map::Element> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::struct_::Field> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::statement::switch_::Case> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::statement::try_::Catch> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::enum_::Label> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::function::Parameter> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::tuple::Element> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::vector<std::string> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const uint64_t v, const location_type& l);


      /// Constructor for symbols with semantic value.
      basic_symbol (typename Base::kind_type t,
                    const semantic_type& v,
                    const location_type& l);

      /// Destroy the symbol.
      ~basic_symbol ();

      /// Destroy contents, and record that is empty.
      void clear ();

      /// Whether empty.
      bool empty () const;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& other);
    };

    /// Type access provider for token (enum) based symbols.
    struct by_type
    {
      /// Default constructor.
      by_type ();

      /// Copy constructor.
      by_type (const by_type& other);

      /// The symbol type as needed by the constructor.
      typedef token_type kind_type;

      /// Constructor from (external) token numbers.
      by_type (kind_type t);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol type from \a that.
      void move (by_type& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_number_type type_get () const;

      /// The token.
      token_type token () const;

      /// The symbol type.
      /// \a empty_symbol when empty.
      /// An int, not token_number_type, to be able to store empty_symbol.
      int type;
    };

    /// "External" symbols: returned by the scanner.
    typedef basic_symbol<by_type> symbol_type;

    // Symbol constructors declarations.
    static inline
    symbol_type
    make_EOD (const location_type& l);

    static inline
    symbol_type
    make_IDENT (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_SCOPED_IDENT (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_SCOPED_FINALIZE (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_DOTTED_IDENT (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_ATTRIBUTE (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_PROPERTY (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_CSTRING (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_CBYTES (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_CREGEXP (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_CADDRESS (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_CPORT (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_CUREAL (const double& v, const location_type& l);

    static inline
    symbol_type
    make_CUINTEGER (const uint64_t& v, const location_type& l);

    static inline
    symbol_type
    make_CBOOL (const bool& v, const location_type& l);

    static inline
    symbol_type
    make_ADD (const location_type& l);

    static inline
    symbol_type
    make_ASSERT (const location_type& l);

    static inline
    symbol_type
    make_ASSERT_EXCEPTION (const location_type& l);

    static inline
    symbol_type
    make_ADDRESS (const location_type& l);

    static inline
    symbol_type
    make_AFTER (const location_type& l);

    static inline
    symbol_type
    make_AND (const location_type& l);

    static inline
    symbol_type
    make_ANY (const location_type& l);

    static inline
    symbol_type
    make_ARROW (const location_type& l);

    static inline
    symbol_type
    make_AUTO (const location_type& l);

    static inline
    symbol_type
    make_AT (const location_type& l);

    static inline
    symbol_type
    make_BEGIN_ (const location_type& l);

    static inline
    symbol_type
    make_BOOL (const location_type& l);

    static inline
    symbol_type
    make_BREAK (const location_type& l);

    static inline
    symbol_type
    make_BYTES (const location_type& l);

    static inline
    symbol_type
    make_CADDR (const location_type& l);

    static inline
    symbol_type
    make_CALLABLE (const location_type& l);

    static inline
    symbol_type
    make_CASE (const location_type& l);

    static inline
    symbol_type
    make_CAST (const location_type& l);

    static inline
    symbol_type
    make_CATCH (const location_type& l);

    static inline
    symbol_type
    make_CHANNEL (const location_type& l);

    static inline
    symbol_type
    make_CLASSIFIER (const location_type& l);

    static inline
    symbol_type
    make_CNULL (const location_type& l);

    static inline
    symbol_type
    make_CONST (const location_type& l);

    static inline
    symbol_type
    make_CONTINUE (const location_type& l);

    static inline
    symbol_type
    make_CONTEXT (const location_type& l);

    static inline
    symbol_type
    make_COPY (const location_type& l);

    static inline
    symbol_type
    make_DECLARE (const location_type& l);

    static inline
    symbol_type
    make_DEFAULT (const location_type& l);

    static inline
    symbol_type
    make_DELETE (const location_type& l);

    static inline
    symbol_type
    make_DIVIDEASSIGN (const location_type& l);

    static inline
    symbol_type
    make_DOLLARDOLLAR (const location_type& l);

    static inline
    symbol_type
    make_DOTDOT (const location_type& l);

    static inline
    symbol_type
    make_REAL (const location_type& l);

    static inline
    symbol_type
    make_ELSE (const location_type& l);

    static inline
    symbol_type
    make_END_ (const location_type& l);

    static inline
    symbol_type
    make_ENUM (const location_type& l);

    static inline
    symbol_type
    make_EQ (const location_type& l);

    static inline
    symbol_type
    make_ERROR (const location_type& l);

    static inline
    symbol_type
    make_EXCEPTION (const location_type& l);

    static inline
    symbol_type
    make_EXPORT (const location_type& l);

    static inline
    symbol_type
    make_EXTERN (const location_type& l);

    static inline
    symbol_type
    make_EXTERN_NO_SUSPEND (const location_type& l);

    static inline
    symbol_type
    make_FILE (const location_type& l);

    static inline
    symbol_type
    make_FINALIZE (const location_type& l);

    static inline
    symbol_type
    make_FOR (const location_type& l);

    static inline
    symbol_type
    make_FROM (const location_type& l);

    static inline
    symbol_type
    make_FUNCTION (const location_type& l);

    static inline
    symbol_type
    make_GEQ (const location_type& l);

    static inline
    symbol_type
    make_GLOBAL (const location_type& l);

    static inline
    symbol_type
    make_HASATTR (const location_type& l);

    static inline
    symbol_type
    make_HOOK (const location_type& l);

    static inline
    symbol_type
    make_IF (const location_type& l);

    static inline
    symbol_type
    make_IMPORT (const location_type& l);

    static inline
    symbol_type
    make_IN (const location_type& l);

    static inline
    symbol_type
    make_INIT (const location_type& l);

    static inline
    symbol_type
    make_INOUT (const location_type& l);

    static inline
    symbol_type
    make_INT (const location_type& l);

    static inline
    symbol_type
    make_INT16 (const location_type& l);

    static inline
    symbol_type
    make_INT32 (const location_type& l);

    static inline
    symbol_type
    make_INT64 (const location_type& l);

    static inline
    symbol_type
    make_INT8 (const location_type& l);

    static inline
    symbol_type
    make_INTERVAL (const location_type& l);

    static inline
    symbol_type
    make_INTERVAL_NS (const location_type& l);

    static inline
    symbol_type
    make_IOSRC (const location_type& l);

    static inline
    symbol_type
    make_ITERATOR (const location_type& l);

    static inline
    symbol_type
    make_CONST_ITERATOR (const location_type& l);

    static inline
    symbol_type
    make_LEQ (const location_type& l);

    static inline
    symbol_type
    make_LIBRARY_TYPE (const location_type& l);

    static inline
    symbol_type
    make_LIST (const location_type& l);

    static inline
    symbol_type
    make_LOCAL (const location_type& l);

    static inline
    symbol_type
    make_MAP (const location_type& l);

    static inline
    symbol_type
    make_MATCH_TOKEN_STATE (const location_type& l);

    static inline
    symbol_type
    make_METHOD (const location_type& l);

    static inline
    symbol_type
    make_MINUSASSIGN (const location_type& l);

    static inline
    symbol_type
    make_MINUSMINUS (const location_type& l);

    static inline
    symbol_type
    make_MOD (const location_type& l);

    static inline
    symbol_type
    make_MODULE (const location_type& l);

    static inline
    symbol_type
    make_MOVE (const location_type& l);

    static inline
    symbol_type
    make_NEW (const location_type& l);

    static inline
    symbol_type
    make_NEQ (const location_type& l);

    static inline
    symbol_type
    make_NETWORK (const location_type& l);

    static inline
    symbol_type
    make_NOT_IN (const location_type& l);

    static inline
    symbol_type
    make_OPTIONAL (const location_type& l);

    static inline
    symbol_type
    make_OR (const location_type& l);

    static inline
    symbol_type
    make_OVERLAY (const location_type& l);

    static inline
    symbol_type
    make_PACK (const location_type& l);

    static inline
    symbol_type
    make_PLUSASSIGN (const location_type& l);

    static inline
    symbol_type
    make_PLUSPLUS (const location_type& l);

    static inline
    symbol_type
    make_PORT (const location_type& l);

    static inline
    symbol_type
    make_POW (const location_type& l);

    static inline
    symbol_type
    make_PREINIT (const location_type& l);

    static inline
    symbol_type
    make_PRIVATE (const location_type& l);

    static inline
    symbol_type
    make_PUBLIC (const location_type& l);

    static inline
    symbol_type
    make_STRONG_REF (const location_type& l);

    static inline
    symbol_type
    make_REGEXP (const location_type& l);

    static inline
    symbol_type
    make_RESULT (const location_type& l);

    static inline
    symbol_type
    make_RETURN (const location_type& l);

    static inline
    symbol_type
    make_SCOPE (const location_type& l);

    static inline
    symbol_type
    make_SET (const location_type& l);

    static inline
    symbol_type
    make_SHIFTLEFT (const location_type& l);

    static inline
    symbol_type
    make_SHIFTRIGHT (const location_type& l);

    static inline
    symbol_type
    make_STREAM (const location_type& l);

    static inline
    symbol_type
    make_STRING (const location_type& l);

    static inline
    symbol_type
    make_STRUCT (const location_type& l);

    static inline
    symbol_type
    make_SWITCH (const location_type& l);

    static inline
    symbol_type
    make_TIME (const location_type& l);

    static inline
    symbol_type
    make_TIME_NS (const location_type& l);

    static inline
    symbol_type
    make_TIMER (const location_type& l);

    static inline
    symbol_type
    make_TIMERMGR (const location_type& l);

    static inline
    symbol_type
    make_TIMESASSIGN (const location_type& l);

    static inline
    symbol_type
    make_THROW (const location_type& l);

    static inline
    symbol_type
    make_TRY (const location_type& l);

    static inline
    symbol_type
    make_TRYATTR (const location_type& l);

    static inline
    symbol_type
    make_TUPLE (const location_type& l);

    static inline
    symbol_type
    make_TYPE (const location_type& l);

    static inline
    symbol_type
    make_TYPEINFO (const location_type& l);

    static inline
    symbol_type
    make_UINT (const location_type& l);

    static inline
    symbol_type
    make_UINT16 (const location_type& l);

    static inline
    symbol_type
    make_UINT32 (const location_type& l);

    static inline
    symbol_type
    make_UINT64 (const location_type& l);

    static inline
    symbol_type
    make_UINT8 (const location_type& l);

    static inline
    symbol_type
    make_UNION (const location_type& l);

    static inline
    symbol_type
    make_UNPACK (const location_type& l);

    static inline
    symbol_type
    make_UNSET (const location_type& l);

    static inline
    symbol_type
    make_VECTOR (const location_type& l);

    static inline
    symbol_type
    make_VIEW (const location_type& l);

    static inline
    symbol_type
    make_VOID (const location_type& l);

    static inline
    symbol_type
    make_WHILE (const location_type& l);

    static inline
    symbol_type
    make_WITH (const location_type& l);

    static inline
    symbol_type
    make_VALUE_REF (const location_type& l);

    static inline
    symbol_type
    make_WEAK_REF (const location_type& l);

    static inline
    symbol_type
    make_YIELD (const location_type& l);


    /// Build a parser object.
    Parser (class Driver* driver_yyarg);
    virtual ~Parser ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

  private:
    /// This class is not copyable.
    Parser (const Parser&);
    Parser& operator= (const Parser&);

    /// State numbers.
    typedef int state_type;

    /// Generate an error message.
    /// \param yystate   the state where the error occurred.
    /// \param yyla      the lookahead token.
    virtual std::string yysyntax_error_ (state_type yystate,
                                         const symbol_type& yyla) const;

    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const short int yypact_ninf_;
    static const short int yytable_ninf_;

    /// Convert a scanner token number \a t to a symbol number.
    static token_number_type yytranslate_ (int t);

    // Tables.
  // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
  // STATE-NUM.
  static const short int yypact_[];

  // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
  // Performed when YYTABLE does not specify something else to do.  Zero
  // means the default is an error.
  static const unsigned short int yydefact_[];

  // YYPGOTO[NTERM-NUM].
  static const short int yypgoto_[];

  // YYDEFGOTO[NTERM-NUM].
  static const short int yydefgoto_[];

  // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
  // positive, shift that token.  If negative, reduce the rule whose
  // number is the opposite.  If YYTABLE_NINF, syntax error.
  static const short int yytable_[];

  static const short int yycheck_[];

  // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
  // symbol of state STATE-NUM.
  static const unsigned short int yystos_[];

  // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
  static const unsigned short int yyr1_[];

  // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
  static const unsigned char yyr2_[];


    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *n);


    /// For a symbol, its name in clear.
    static const char* const yytname_[];
#if YYDEBUG
  // YYRLINE[YYN] -- Source line where rule number YYN was defined.
  static const unsigned short int yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r);
    /// Print the state stack on the debug stream.
    virtual void yystack_print_ ();

    // Debugging.
    int yydebug_;
    std::ostream* yycdebug_;

    /// \brief Display a symbol type, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state ();

      /// The symbol type as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s);

      /// Copy constructor.
      by_state (const by_state& other);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol type from \a that.
      void move (by_state& that);

      /// The (internal) type number (corresponding to \a state).
      /// \a empty_symbol when empty.
      symbol_number_type type_get () const;

      /// The state number used to denote an empty symbol.
      enum { empty_state = -1 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, symbol_type& sym);
      /// Assignment, needed by push_back.
      stack_symbol_type& operator= (const stack_symbol_type& that);
    };

    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, stack_symbol_type& s);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, state_type s, symbol_type& sym);

    /// Pop \a n symbols the three stacks.
    void yypop_ (unsigned int n = 1);

    /// Constants.
    enum
    {
      yyeof_ = 0,
      yylast_ = 5515,     ///< Last index in yytable_.
      yynnts_ = 112,  ///< Number of nonterminal symbols.
      yyfinal_ = 5, ///< Termination state number.
      yyterror_ = 1,
      yyerrcode_ = 256,
      yyntokens_ = 174  ///< Number of tokens.
    };


    // User arguments.
    class Driver* driver;
  };


#line 27 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:377
} } } // hilti::detail::parser
#line 1625 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.h" // lalr1.cc:377




#endif // !YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_6_0_3_BUILD_AUXIL_SPICY_HILTI_SRC_AUTOGEN_PARSER_H_INCLUDED
