// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.
#line 11 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:404

namespace spicy { namespace detail { class Parser; } }

#include <spicy/compiler/detail/parser/driver.h>

#line 40 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:404


#include <spicy/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(spicy::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column, l.end.column));
}

static hilti::Type iteratorForType(hilti::Type t, bool const_, hilti::Meta m) {
    if ( hilti::type::isIterable(t) )
        return t.iteratorType(const_);
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", t), m.location());
        return hilti::type::Error(m);
        }
}

static hilti::Type viewForType(hilti::Type t, hilti::Meta m) {
    if ( hilti::type::isViewable(t) )
        return t.viewType();
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", t), m.location());
        return hilti::type::Error(m);
        }
}

/**
 * Checks if an unsigned integer value can be represented as an int64_t.
 *
 * @param x value to check
 * @param positive if false, check if ``-x`` can be represented instead of ``x`` itself.
 * @param m location information to associate with error message.
 * @return *x* on success, or zero on failure as a temporary stand-in; in the
 * latter cases an error is reported, too
 */
static uint64_t check_int64_range(uint64_t x, bool positive, const hilti::Meta& m) {
    uint64_t max = (positive ? std::numeric_limits<int64_t>::max() : std::fabs(std::numeric_limits<int64_t>::min()));

    if ( x <= max )
        return x;

    hilti::logger().error("signed integer value out of range", m.location());
    return 0; // Return dummy value
}

#define __loc__ toMeta(yylhs.location)

static int _field_width = 0;

// We keep a stack of doc strings here that's maintained during parsing. There
// would actually be a much nicer way of doing this through Bison's mid-action
// rules, but unfortunately those have a bug with Bison < 3.1 that prevents
// passing results back from a mid-action rule; see
// https://stackoverflow.com/questions/44811550/bison-c-mid-rule-value-lost-with-variants.
//
// Bison 3.1 fixes this and introduces a new, nicer typing syntax for
// mid-action rules as well; see
// https://www.gnu.org/software/bison/manual/html_node/Typed-Mid_002dRule-Actions.html#Typed-Mid_002dRule-Actions
// Unfortunately, we cannot rely on having 3.1 yet, because some of our
// supported platforms do not provide it. Once we can, we should get rid of
// this stack and move to that new syntax instead.
static std::vector<hilti::DocString> _docs;


#line 110 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "__parser.h"

// User implementation prologue.

#line 124 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:412


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 28 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:479
namespace spicy { namespace detail { namespace parser {
#line 210 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Parser::Parser (class Driver* driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {}

  Parser::~Parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  Parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
      switch (other.type_get ())
    {
      case 19: // "bool value"
      case 255: // opt_skip
      case 257: // opt_skip_
        value.copy< bool > (other.value);
        break;

      case 16: // "real value"
        value.copy< double > (other.value);
        break;

      case 271: // unit_hook_attribute
      case 322: // attribute
        value.copy< hilti::Attribute > (other.value);
        break;

      case 250: // unit_field_ctor
      case 300: // ctor
      case 302: // tuple
      case 307: // list
      case 308: // vector
      case 309: // set
      case 310: // map
      case 311: // struct_
      case 314: // regexp
        value.copy< hilti::Ctor > (other.value);
        break;

      case 181: // global_scope_decl
      case 182: // type_decl
      case 184: // constant_decl
      case 187: // local_decl
      case 188: // local_init_decl
      case 189: // global_decl
      case 193: // function_decl
      case 196: // import_decl
      case 197: // property_decl
      case 198: // hook_decl
      case 230: // struct_field
        value.copy< hilti::Declaration > (other.value);
        break;

      case 277: // expr
      case 282: // expr_0
      case 283: // expr_1
      case 284: // expr_2
      case 285: // expr_3
      case 286: // expr_4
      case 287: // expr_5
      case 288: // expr_6
      case 289: // expr_7
      case 290: // expr_8
      case 291: // expr_9
      case 292: // expr_a
      case 293: // expr_b
      case 294: // expr_c
      case 295: // expr_d
      case 296: // expr_e
      case 297: // expr_f
      case 298: // expr_g
      case 299: // member_expr
      case 301: // ctor_expr
      case 305: // tuple_elem
      case 306: // tuple_expr
        value.copy< hilti::Expression > (other.value);
        break;

      case 175: // local_id
      case 176: // scoped_id
      case 177: // dotted_id
      case 268: // unit_hook_id
        value.copy< hilti::ID > (other.value);
        break;

      case 209: // block
      case 210: // braced_block
      case 213: // stmt
      case 217: // stmt_decl
      case 218: // stmt_expr
        value.copy< hilti::Statement > (other.value);
        break;

      case 219: // base_type_no_ref
      case 220: // reference_type
      case 221: // base_type
      case 222: // type
      case 225: // tuple_type
      case 228: // struct_type
      case 231: // enum_type
      case 234: // bitfield_type
      case 239: // unit_type
        value.copy< hilti::Type > (other.value);
        break;

      case 321: // map_elem
        value.copy< hilti::ctor::map::Element > (other.value);
        break;

      case 313: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (other.value);
        break;

      case 199: // opt_linkage
        value.copy< hilti::declaration::Linkage > (other.value);
        break;

      case 207: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (other.value);
        break;

      case 201: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (other.value);
        break;

      case 216: // switch_case
        value.copy< hilti::statement::switch_::Case > (other.value);
        break;

      case 233: // enum_label
        value.copy< hilti::type::enum_::Label > (other.value);
        break;

      case 200: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (other.value);
        break;

      case 204: // func_param
        value.copy< hilti::type::function::Parameter > (other.value);
        break;

      case 205: // func_result
      case 206: // opt_func_result
        value.copy< hilti::type::function::Result > (other.value);
        break;

      case 227: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (other.value);
        break;

      case 248: // const_sint
        value.copy< int64_t > (other.value);
        break;

      case 254: // opt_unit_field_engine
      case 272: // opt_hook_engine
        value.copy< spicy::Engine > (other.value);
        break;

      case 265: // unit_hook
        value.copy< spicy::Hook > (other.value);
        break;

      case 238: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (other.value);
        break;

      case 243: // unit_item
      case 244: // unit_variable
      case 245: // unit_sink
      case 246: // unit_property
      case 247: // unit_field
      case 251: // unit_field_in_container
      case 252: // unit_wide_hook
      case 273: // unit_switch
        value.copy< spicy::type::unit::Item > (other.value);
        break;

      case 276: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (other.value);
        break;

      case 267: // opt_unit_hook_attributes
      case 323: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (other.value);
        break;

      case 208: // opt_init_expression
      case 259: // unit_field_repeat
      case 260: // opt_unit_field_repeat
      case 261: // opt_unit_field_condition
      case 274: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (other.value);
        break;

      case 253: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (other.value);
        break;

      case 214: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (other.value);
        break;

      case 192: // global_decl_type_and_init
        value.copy< std::pair<hilti::Type, std::optional<hilti::Expression>> > (other.value);
        break;

      case 180: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (other.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 316: // re_pattern_constant
        value.copy< std::string > (other.value);
        break;

      case 229: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (other.value);
        break;

      case 258: // opt_unit_field_args
      case 262: // opt_unit_field_sinks
      case 280: // opt_exprs
      case 281: // exprs
      case 303: // opt_tuple_elems1
      case 304: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (other.value);
        break;

      case 211: // opt_stmts
      case 212: // stmts
        value.copy< std::vector<hilti::Statement> > (other.value);
        break;

      case 319: // opt_map_elems
      case 320: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (other.value);
        break;

      case 312: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (other.value);
        break;

      case 215: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (other.value);
        break;

      case 232: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (other.value);
        break;

      case 202: // opt_func_params
      case 203: // func_params
      case 240: // opt_unit_params
      case 266: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (other.value);
        break;

      case 226: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (other.value);
        break;

      case 263: // opt_unit_item_hooks
      case 264: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (other.value);
        break;

      case 236: // opt_bitfield_bits
      case 237: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (other.value);
        break;

      case 241: // unit_items
      case 242: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (other.value);
        break;

      case 275: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (other.value);
        break;

      case 315: // re_patterns
        value.copy< std::vector<std::string> > (other.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 249: // const_uint
        value.copy< uint64_t > (other.value);
        break;

      default:
        break;
    }

  }


  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {
    (void) v;
      switch (this->type_get ())
    {
      case 19: // "bool value"
      case 255: // opt_skip
      case 257: // opt_skip_
        value.copy< bool > (v);
        break;

      case 16: // "real value"
        value.copy< double > (v);
        break;

      case 271: // unit_hook_attribute
      case 322: // attribute
        value.copy< hilti::Attribute > (v);
        break;

      case 250: // unit_field_ctor
      case 300: // ctor
      case 302: // tuple
      case 307: // list
      case 308: // vector
      case 309: // set
      case 310: // map
      case 311: // struct_
      case 314: // regexp
        value.copy< hilti::Ctor > (v);
        break;

      case 181: // global_scope_decl
      case 182: // type_decl
      case 184: // constant_decl
      case 187: // local_decl
      case 188: // local_init_decl
      case 189: // global_decl
      case 193: // function_decl
      case 196: // import_decl
      case 197: // property_decl
      case 198: // hook_decl
      case 230: // struct_field
        value.copy< hilti::Declaration > (v);
        break;

      case 277: // expr
      case 282: // expr_0
      case 283: // expr_1
      case 284: // expr_2
      case 285: // expr_3
      case 286: // expr_4
      case 287: // expr_5
      case 288: // expr_6
      case 289: // expr_7
      case 290: // expr_8
      case 291: // expr_9
      case 292: // expr_a
      case 293: // expr_b
      case 294: // expr_c
      case 295: // expr_d
      case 296: // expr_e
      case 297: // expr_f
      case 298: // expr_g
      case 299: // member_expr
      case 301: // ctor_expr
      case 305: // tuple_elem
      case 306: // tuple_expr
        value.copy< hilti::Expression > (v);
        break;

      case 175: // local_id
      case 176: // scoped_id
      case 177: // dotted_id
      case 268: // unit_hook_id
        value.copy< hilti::ID > (v);
        break;

      case 209: // block
      case 210: // braced_block
      case 213: // stmt
      case 217: // stmt_decl
      case 218: // stmt_expr
        value.copy< hilti::Statement > (v);
        break;

      case 219: // base_type_no_ref
      case 220: // reference_type
      case 221: // base_type
      case 222: // type
      case 225: // tuple_type
      case 228: // struct_type
      case 231: // enum_type
      case 234: // bitfield_type
      case 239: // unit_type
        value.copy< hilti::Type > (v);
        break;

      case 321: // map_elem
        value.copy< hilti::ctor::map::Element > (v);
        break;

      case 313: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (v);
        break;

      case 199: // opt_linkage
        value.copy< hilti::declaration::Linkage > (v);
        break;

      case 207: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (v);
        break;

      case 201: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (v);
        break;

      case 216: // switch_case
        value.copy< hilti::statement::switch_::Case > (v);
        break;

      case 233: // enum_label
        value.copy< hilti::type::enum_::Label > (v);
        break;

      case 200: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (v);
        break;

      case 204: // func_param
        value.copy< hilti::type::function::Parameter > (v);
        break;

      case 205: // func_result
      case 206: // opt_func_result
        value.copy< hilti::type::function::Result > (v);
        break;

      case 227: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (v);
        break;

      case 248: // const_sint
        value.copy< int64_t > (v);
        break;

      case 254: // opt_unit_field_engine
      case 272: // opt_hook_engine
        value.copy< spicy::Engine > (v);
        break;

      case 265: // unit_hook
        value.copy< spicy::Hook > (v);
        break;

      case 238: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (v);
        break;

      case 243: // unit_item
      case 244: // unit_variable
      case 245: // unit_sink
      case 246: // unit_property
      case 247: // unit_field
      case 251: // unit_field_in_container
      case 252: // unit_wide_hook
      case 273: // unit_switch
        value.copy< spicy::type::unit::Item > (v);
        break;

      case 276: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (v);
        break;

      case 267: // opt_unit_hook_attributes
      case 323: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (v);
        break;

      case 208: // opt_init_expression
      case 259: // unit_field_repeat
      case 260: // opt_unit_field_repeat
      case 261: // opt_unit_field_condition
      case 274: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (v);
        break;

      case 253: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (v);
        break;

      case 214: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (v);
        break;

      case 192: // global_decl_type_and_init
        value.copy< std::pair<hilti::Type, std::optional<hilti::Expression>> > (v);
        break;

      case 180: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (v);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 316: // re_pattern_constant
        value.copy< std::string > (v);
        break;

      case 229: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (v);
        break;

      case 258: // opt_unit_field_args
      case 262: // opt_unit_field_sinks
      case 280: // opt_exprs
      case 281: // exprs
      case 303: // opt_tuple_elems1
      case 304: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (v);
        break;

      case 211: // opt_stmts
      case 212: // stmts
        value.copy< std::vector<hilti::Statement> > (v);
        break;

      case 319: // opt_map_elems
      case 320: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (v);
        break;

      case 312: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (v);
        break;

      case 215: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (v);
        break;

      case 232: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (v);
        break;

      case 202: // opt_func_params
      case 203: // func_params
      case 240: // opt_unit_params
      case 266: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (v);
        break;

      case 226: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (v);
        break;

      case 263: // opt_unit_item_hooks
      case 264: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (v);
        break;

      case 236: // opt_bitfield_bits
      case 237: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (v);
        break;

      case 241: // unit_items
      case 242: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (v);
        break;

      case 275: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (v);
        break;

      case 315: // re_patterns
        value.copy< std::vector<std::string> > (v);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 249: // const_uint
        value.copy< uint64_t > (v);
        break;

      default:
        break;
    }
}


  // Implementation of basic_symbol constructor for each type.

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const bool v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const double v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Attribute v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Ctor v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Declaration v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Expression v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ID v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Statement v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Type v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ctor::map::Element v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ctor::struct_::Field v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::declaration::Linkage v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::declaration::parameter::Kind v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::function::CallingConvention v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::statement::switch_::Case v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::enum_::Label v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Flavor v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Parameter v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Result v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::tuple::Element v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const int64_t v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::Engine v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::Hook v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::type::bitfield::Bits v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::type::unit::Item v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::type::unit::item::switch_::Case v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::AttributeSet> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::Expression> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::ID> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::Statement> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::pair<hilti::Type, std::optional<hilti::Expression>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::string v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Declaration> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Expression> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Statement> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::map::Element> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::struct_::Field> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::statement::switch_::Case> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::enum_::Label> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::function::Parameter> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::tuple::Element> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::Hook> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::type::bitfield::Bits> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::type::unit::Item> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::type::unit::item::switch_::Case> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<std::string> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const uint64_t v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  template <typename Base>
  inline
  Parser::basic_symbol<Base>::~basic_symbol ()
  {
    clear ();
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::clear ()
  {
    // User destructor.
    symbol_number_type yytype = this->type_get ();
    basic_symbol<Base>& yysym = *this;
    (void) yysym;
    switch (yytype)
    {
   default:
      break;
    }

    // Type destructor.
    switch (yytype)
    {
      case 19: // "bool value"
      case 255: // opt_skip
      case 257: // opt_skip_
        value.template destroy< bool > ();
        break;

      case 16: // "real value"
        value.template destroy< double > ();
        break;

      case 271: // unit_hook_attribute
      case 322: // attribute
        value.template destroy< hilti::Attribute > ();
        break;

      case 250: // unit_field_ctor
      case 300: // ctor
      case 302: // tuple
      case 307: // list
      case 308: // vector
      case 309: // set
      case 310: // map
      case 311: // struct_
      case 314: // regexp
        value.template destroy< hilti::Ctor > ();
        break;

      case 181: // global_scope_decl
      case 182: // type_decl
      case 184: // constant_decl
      case 187: // local_decl
      case 188: // local_init_decl
      case 189: // global_decl
      case 193: // function_decl
      case 196: // import_decl
      case 197: // property_decl
      case 198: // hook_decl
      case 230: // struct_field
        value.template destroy< hilti::Declaration > ();
        break;

      case 277: // expr
      case 282: // expr_0
      case 283: // expr_1
      case 284: // expr_2
      case 285: // expr_3
      case 286: // expr_4
      case 287: // expr_5
      case 288: // expr_6
      case 289: // expr_7
      case 290: // expr_8
      case 291: // expr_9
      case 292: // expr_a
      case 293: // expr_b
      case 294: // expr_c
      case 295: // expr_d
      case 296: // expr_e
      case 297: // expr_f
      case 298: // expr_g
      case 299: // member_expr
      case 301: // ctor_expr
      case 305: // tuple_elem
      case 306: // tuple_expr
        value.template destroy< hilti::Expression > ();
        break;

      case 175: // local_id
      case 176: // scoped_id
      case 177: // dotted_id
      case 268: // unit_hook_id
        value.template destroy< hilti::ID > ();
        break;

      case 209: // block
      case 210: // braced_block
      case 213: // stmt
      case 217: // stmt_decl
      case 218: // stmt_expr
        value.template destroy< hilti::Statement > ();
        break;

      case 219: // base_type_no_ref
      case 220: // reference_type
      case 221: // base_type
      case 222: // type
      case 225: // tuple_type
      case 228: // struct_type
      case 231: // enum_type
      case 234: // bitfield_type
      case 239: // unit_type
        value.template destroy< hilti::Type > ();
        break;

      case 321: // map_elem
        value.template destroy< hilti::ctor::map::Element > ();
        break;

      case 313: // struct_elem
        value.template destroy< hilti::ctor::struct_::Field > ();
        break;

      case 199: // opt_linkage
        value.template destroy< hilti::declaration::Linkage > ();
        break;

      case 207: // opt_func_param_kind
        value.template destroy< hilti::declaration::parameter::Kind > ();
        break;

      case 201: // opt_func_cc
        value.template destroy< hilti::function::CallingConvention > ();
        break;

      case 216: // switch_case
        value.template destroy< hilti::statement::switch_::Case > ();
        break;

      case 233: // enum_label
        value.template destroy< hilti::type::enum_::Label > ();
        break;

      case 200: // opt_func_flavor
        value.template destroy< hilti::type::function::Flavor > ();
        break;

      case 204: // func_param
        value.template destroy< hilti::type::function::Parameter > ();
        break;

      case 205: // func_result
      case 206: // opt_func_result
        value.template destroy< hilti::type::function::Result > ();
        break;

      case 227: // tuple_type_elem
        value.template destroy< hilti::type::tuple::Element > ();
        break;

      case 248: // const_sint
        value.template destroy< int64_t > ();
        break;

      case 254: // opt_unit_field_engine
      case 272: // opt_hook_engine
        value.template destroy< spicy::Engine > ();
        break;

      case 265: // unit_hook
        value.template destroy< spicy::Hook > ();
        break;

      case 238: // bitfield_bits_spec
        value.template destroy< spicy::type::bitfield::Bits > ();
        break;

      case 243: // unit_item
      case 244: // unit_variable
      case 245: // unit_sink
      case 246: // unit_property
      case 247: // unit_field
      case 251: // unit_field_in_container
      case 252: // unit_wide_hook
      case 273: // unit_switch
        value.template destroy< spicy::type::unit::Item > ();
        break;

      case 276: // unit_switch_case
        value.template destroy< spicy::type::unit::item::switch_::Case > ();
        break;

      case 267: // opt_unit_hook_attributes
      case 323: // opt_attributes
        value.template destroy< std::optional<hilti::AttributeSet> > ();
        break;

      case 208: // opt_init_expression
      case 259: // unit_field_repeat
      case 260: // opt_unit_field_repeat
      case 261: // opt_unit_field_condition
      case 274: // opt_unit_switch_expr
        value.template destroy< std::optional<hilti::Expression> > ();
        break;

      case 253: // opt_unit_field_id
        value.template destroy< std::optional<hilti::ID> > ();
        break;

      case 214: // opt_else_block
        value.template destroy< std::optional<hilti::Statement> > ();
        break;

      case 192: // global_decl_type_and_init
        value.template destroy< std::pair<hilti::Type, std::optional<hilti::Expression>> > ();
        break;

      case 180: // global_scope_items
        value.template destroy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 316: // re_pattern_constant
        value.template destroy< std::string > ();
        break;

      case 229: // struct_fields
        value.template destroy< std::vector<hilti::Declaration> > ();
        break;

      case 258: // opt_unit_field_args
      case 262: // opt_unit_field_sinks
      case 280: // opt_exprs
      case 281: // exprs
      case 303: // opt_tuple_elems1
      case 304: // opt_tuple_elems2
        value.template destroy< std::vector<hilti::Expression> > ();
        break;

      case 211: // opt_stmts
      case 212: // stmts
        value.template destroy< std::vector<hilti::Statement> > ();
        break;

      case 319: // opt_map_elems
      case 320: // map_elems
        value.template destroy< std::vector<hilti::ctor::map::Element> > ();
        break;

      case 312: // struct_elems
        value.template destroy< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case 215: // switch_cases
        value.template destroy< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case 232: // enum_labels
        value.template destroy< std::vector<hilti::type::enum_::Label> > ();
        break;

      case 202: // opt_func_params
      case 203: // func_params
      case 240: // opt_unit_params
      case 266: // opt_unit_hook_params
        value.template destroy< std::vector<hilti::type::function::Parameter> > ();
        break;

      case 226: // tuple_type_elems
        value.template destroy< std::vector<hilti::type::tuple::Element> > ();
        break;

      case 263: // opt_unit_item_hooks
      case 264: // unit_hooks
        value.template destroy< std::vector<spicy::Hook> > ();
        break;

      case 236: // opt_bitfield_bits
      case 237: // bitfield_bits
        value.template destroy< std::vector<spicy::type::bitfield::Bits> > ();
        break;

      case 241: // unit_items
      case 242: // opt_unit_items
        value.template destroy< std::vector<spicy::type::unit::Item> > ();
        break;

      case 275: // unit_switch_cases
        value.template destroy< std::vector<spicy::type::unit::item::switch_::Case> > ();
        break;

      case 315: // re_patterns
        value.template destroy< std::vector<std::string> > ();
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 249: // const_uint
        value.template destroy< uint64_t > ();
        break;

      default:
        break;
    }

    Base::clear ();
  }

  template <typename Base>
  inline
  bool
  Parser::basic_symbol<Base>::empty () const
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
      switch (this->type_get ())
    {
      case 19: // "bool value"
      case 255: // opt_skip
      case 257: // opt_skip_
        value.move< bool > (s.value);
        break;

      case 16: // "real value"
        value.move< double > (s.value);
        break;

      case 271: // unit_hook_attribute
      case 322: // attribute
        value.move< hilti::Attribute > (s.value);
        break;

      case 250: // unit_field_ctor
      case 300: // ctor
      case 302: // tuple
      case 307: // list
      case 308: // vector
      case 309: // set
      case 310: // map
      case 311: // struct_
      case 314: // regexp
        value.move< hilti::Ctor > (s.value);
        break;

      case 181: // global_scope_decl
      case 182: // type_decl
      case 184: // constant_decl
      case 187: // local_decl
      case 188: // local_init_decl
      case 189: // global_decl
      case 193: // function_decl
      case 196: // import_decl
      case 197: // property_decl
      case 198: // hook_decl
      case 230: // struct_field
        value.move< hilti::Declaration > (s.value);
        break;

      case 277: // expr
      case 282: // expr_0
      case 283: // expr_1
      case 284: // expr_2
      case 285: // expr_3
      case 286: // expr_4
      case 287: // expr_5
      case 288: // expr_6
      case 289: // expr_7
      case 290: // expr_8
      case 291: // expr_9
      case 292: // expr_a
      case 293: // expr_b
      case 294: // expr_c
      case 295: // expr_d
      case 296: // expr_e
      case 297: // expr_f
      case 298: // expr_g
      case 299: // member_expr
      case 301: // ctor_expr
      case 305: // tuple_elem
      case 306: // tuple_expr
        value.move< hilti::Expression > (s.value);
        break;

      case 175: // local_id
      case 176: // scoped_id
      case 177: // dotted_id
      case 268: // unit_hook_id
        value.move< hilti::ID > (s.value);
        break;

      case 209: // block
      case 210: // braced_block
      case 213: // stmt
      case 217: // stmt_decl
      case 218: // stmt_expr
        value.move< hilti::Statement > (s.value);
        break;

      case 219: // base_type_no_ref
      case 220: // reference_type
      case 221: // base_type
      case 222: // type
      case 225: // tuple_type
      case 228: // struct_type
      case 231: // enum_type
      case 234: // bitfield_type
      case 239: // unit_type
        value.move< hilti::Type > (s.value);
        break;

      case 321: // map_elem
        value.move< hilti::ctor::map::Element > (s.value);
        break;

      case 313: // struct_elem
        value.move< hilti::ctor::struct_::Field > (s.value);
        break;

      case 199: // opt_linkage
        value.move< hilti::declaration::Linkage > (s.value);
        break;

      case 207: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (s.value);
        break;

      case 201: // opt_func_cc
        value.move< hilti::function::CallingConvention > (s.value);
        break;

      case 216: // switch_case
        value.move< hilti::statement::switch_::Case > (s.value);
        break;

      case 233: // enum_label
        value.move< hilti::type::enum_::Label > (s.value);
        break;

      case 200: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (s.value);
        break;

      case 204: // func_param
        value.move< hilti::type::function::Parameter > (s.value);
        break;

      case 205: // func_result
      case 206: // opt_func_result
        value.move< hilti::type::function::Result > (s.value);
        break;

      case 227: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (s.value);
        break;

      case 248: // const_sint
        value.move< int64_t > (s.value);
        break;

      case 254: // opt_unit_field_engine
      case 272: // opt_hook_engine
        value.move< spicy::Engine > (s.value);
        break;

      case 265: // unit_hook
        value.move< spicy::Hook > (s.value);
        break;

      case 238: // bitfield_bits_spec
        value.move< spicy::type::bitfield::Bits > (s.value);
        break;

      case 243: // unit_item
      case 244: // unit_variable
      case 245: // unit_sink
      case 246: // unit_property
      case 247: // unit_field
      case 251: // unit_field_in_container
      case 252: // unit_wide_hook
      case 273: // unit_switch
        value.move< spicy::type::unit::Item > (s.value);
        break;

      case 276: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case > (s.value);
        break;

      case 267: // opt_unit_hook_attributes
      case 323: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (s.value);
        break;

      case 208: // opt_init_expression
      case 259: // unit_field_repeat
      case 260: // opt_unit_field_repeat
      case 261: // opt_unit_field_condition
      case 274: // opt_unit_switch_expr
        value.move< std::optional<hilti::Expression> > (s.value);
        break;

      case 253: // opt_unit_field_id
        value.move< std::optional<hilti::ID> > (s.value);
        break;

      case 214: // opt_else_block
        value.move< std::optional<hilti::Statement> > (s.value);
        break;

      case 192: // global_decl_type_and_init
        value.move< std::pair<hilti::Type, std::optional<hilti::Expression>> > (s.value);
        break;

      case 180: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (s.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 316: // re_pattern_constant
        value.move< std::string > (s.value);
        break;

      case 229: // struct_fields
        value.move< std::vector<hilti::Declaration> > (s.value);
        break;

      case 258: // opt_unit_field_args
      case 262: // opt_unit_field_sinks
      case 280: // opt_exprs
      case 281: // exprs
      case 303: // opt_tuple_elems1
      case 304: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (s.value);
        break;

      case 211: // opt_stmts
      case 212: // stmts
        value.move< std::vector<hilti::Statement> > (s.value);
        break;

      case 319: // opt_map_elems
      case 320: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (s.value);
        break;

      case 312: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (s.value);
        break;

      case 215: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (s.value);
        break;

      case 232: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (s.value);
        break;

      case 202: // opt_func_params
      case 203: // func_params
      case 240: // opt_unit_params
      case 266: // opt_unit_hook_params
        value.move< std::vector<hilti::type::function::Parameter> > (s.value);
        break;

      case 226: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (s.value);
        break;

      case 263: // opt_unit_item_hooks
      case 264: // unit_hooks
        value.move< std::vector<spicy::Hook> > (s.value);
        break;

      case 236: // opt_bitfield_bits
      case 237: // bitfield_bits
        value.move< std::vector<spicy::type::bitfield::Bits> > (s.value);
        break;

      case 241: // unit_items
      case 242: // opt_unit_items
        value.move< std::vector<spicy::type::unit::Item> > (s.value);
        break;

      case 275: // unit_switch_cases
        value.move< std::vector<spicy::type::unit::item::switch_::Case> > (s.value);
        break;

      case 315: // re_patterns
        value.move< std::vector<std::string> > (s.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 249: // const_uint
        value.move< uint64_t > (s.value);
        break;

      default:
        break;
    }

    location = s.location;
  }

  // by_type.
  inline
  Parser::by_type::by_type ()
    : type (empty_symbol)
  {}

  inline
  Parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  Parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  Parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  inline
  void
  Parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  inline
  int
  Parser::by_type::type_get () const
  {
    return type;
  }
  // Implementation of make_symbol for each symbol type.
  Parser::symbol_type
  Parser::make_EOD (const location_type& l)
  {
    return symbol_type (token::EOD, l);
  }

  Parser::symbol_type
  Parser::make_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_SCOPED_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::SCOPED_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_DOTTED_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::DOTTED_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_HOOK_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::HOOK_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_DOLLAR_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::DOLLAR_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_ATTRIBUTE (const std::string& v, const location_type& l)
  {
    return symbol_type (token::ATTRIBUTE, v, l);
  }

  Parser::symbol_type
  Parser::make_PROPERTY (const std::string& v, const location_type& l)
  {
    return symbol_type (token::PROPERTY, v, l);
  }

  Parser::symbol_type
  Parser::make_PREPROCESSOR (const std::string& v, const location_type& l)
  {
    return symbol_type (token::PREPROCESSOR, v, l);
  }

  Parser::symbol_type
  Parser::make_CSTRING (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CSTRING, v, l);
  }

  Parser::symbol_type
  Parser::make_CBYTES (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CBYTES, v, l);
  }

  Parser::symbol_type
  Parser::make_CREGEXP (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CREGEXP, v, l);
  }

  Parser::symbol_type
  Parser::make_CADDRESS (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CADDRESS, v, l);
  }

  Parser::symbol_type
  Parser::make_CPORT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CPORT, v, l);
  }

  Parser::symbol_type
  Parser::make_CUREAL (const double& v, const location_type& l)
  {
    return symbol_type (token::CUREAL, v, l);
  }

  Parser::symbol_type
  Parser::make_CUINTEGER (const uint64_t& v, const location_type& l)
  {
    return symbol_type (token::CUINTEGER, v, l);
  }

  Parser::symbol_type
  Parser::make_DOLLAR_NUMBER (const uint64_t& v, const location_type& l)
  {
    return symbol_type (token::DOLLAR_NUMBER, v, l);
  }

  Parser::symbol_type
  Parser::make_CBOOL (const bool& v, const location_type& l)
  {
    return symbol_type (token::CBOOL, v, l);
  }

  Parser::symbol_type
  Parser::make_CNULL (const location_type& l)
  {
    return symbol_type (token::CNULL, l);
  }

  Parser::symbol_type
  Parser::make_ASSERT (const location_type& l)
  {
    return symbol_type (token::ASSERT, l);
  }

  Parser::symbol_type
  Parser::make_ASSERT_EXCEPTION (const location_type& l)
  {
    return symbol_type (token::ASSERT_EXCEPTION, l);
  }

  Parser::symbol_type
  Parser::make_ADD (const location_type& l)
  {
    return symbol_type (token::ADD, l);
  }

  Parser::symbol_type
  Parser::make_ADDRESS (const location_type& l)
  {
    return symbol_type (token::ADDRESS, l);
  }

  Parser::symbol_type
  Parser::make_AND (const location_type& l)
  {
    return symbol_type (token::AND, l);
  }

  Parser::symbol_type
  Parser::make_ANY (const location_type& l)
  {
    return symbol_type (token::ANY, l);
  }

  Parser::symbol_type
  Parser::make_ARROW (const location_type& l)
  {
    return symbol_type (token::ARROW, l);
  }

  Parser::symbol_type
  Parser::make_AUTO (const location_type& l)
  {
    return symbol_type (token::AUTO, l);
  }

  Parser::symbol_type
  Parser::make_BITFIELD (const location_type& l)
  {
    return symbol_type (token::BITFIELD, l);
  }

  Parser::symbol_type
  Parser::make_BEGIN_ (const location_type& l)
  {
    return symbol_type (token::BEGIN_, l);
  }

  Parser::symbol_type
  Parser::make_BOOL (const location_type& l)
  {
    return symbol_type (token::BOOL, l);
  }

  Parser::symbol_type
  Parser::make_BREAK (const location_type& l)
  {
    return symbol_type (token::BREAK, l);
  }

  Parser::symbol_type
  Parser::make_BYTES (const location_type& l)
  {
    return symbol_type (token::BYTES, l);
  }

  Parser::symbol_type
  Parser::make_CADDR (const location_type& l)
  {
    return symbol_type (token::CADDR, l);
  }

  Parser::symbol_type
  Parser::make_CASE (const location_type& l)
  {
    return symbol_type (token::CASE, l);
  }

  Parser::symbol_type
  Parser::make_CAST (const location_type& l)
  {
    return symbol_type (token::CAST, l);
  }

  Parser::symbol_type
  Parser::make_CATCH (const location_type& l)
  {
    return symbol_type (token::CATCH, l);
  }

  Parser::symbol_type
  Parser::make_CONST (const location_type& l)
  {
    return symbol_type (token::CONST, l);
  }

  Parser::symbol_type
  Parser::make_CONSTANT (const location_type& l)
  {
    return symbol_type (token::CONSTANT, l);
  }

  Parser::symbol_type
  Parser::make_CONTINUE (const location_type& l)
  {
    return symbol_type (token::CONTINUE, l);
  }

  Parser::symbol_type
  Parser::make_DEBUG_ (const location_type& l)
  {
    return symbol_type (token::DEBUG_, l);
  }

  Parser::symbol_type
  Parser::make_DECLARE (const location_type& l)
  {
    return symbol_type (token::DECLARE, l);
  }

  Parser::symbol_type
  Parser::make_DEFAULT (const location_type& l)
  {
    return symbol_type (token::DEFAULT, l);
  }

  Parser::symbol_type
  Parser::make_DELETE (const location_type& l)
  {
    return symbol_type (token::DELETE, l);
  }

  Parser::symbol_type
  Parser::make_DIVIDEASSIGN (const location_type& l)
  {
    return symbol_type (token::DIVIDEASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_DOLLARDOLLAR (const location_type& l)
  {
    return symbol_type (token::DOLLARDOLLAR, l);
  }

  Parser::symbol_type
  Parser::make_DOTDOT (const location_type& l)
  {
    return symbol_type (token::DOTDOT, l);
  }

  Parser::symbol_type
  Parser::make_REAL (const location_type& l)
  {
    return symbol_type (token::REAL, l);
  }

  Parser::symbol_type
  Parser::make_ELSE (const location_type& l)
  {
    return symbol_type (token::ELSE, l);
  }

  Parser::symbol_type
  Parser::make_END_ (const location_type& l)
  {
    return symbol_type (token::END_, l);
  }

  Parser::symbol_type
  Parser::make_ENUM (const location_type& l)
  {
    return symbol_type (token::ENUM, l);
  }

  Parser::symbol_type
  Parser::make_EQ (const location_type& l)
  {
    return symbol_type (token::EQ, l);
  }

  Parser::symbol_type
  Parser::make_EXCEPTION (const location_type& l)
  {
    return symbol_type (token::EXCEPTION, l);
  }

  Parser::symbol_type
  Parser::make_EXPORT (const location_type& l)
  {
    return symbol_type (token::EXPORT, l);
  }

  Parser::symbol_type
  Parser::make_FILE (const location_type& l)
  {
    return symbol_type (token::FILE, l);
  }

  Parser::symbol_type
  Parser::make_FOR (const location_type& l)
  {
    return symbol_type (token::FOR, l);
  }

  Parser::symbol_type
  Parser::make_FOREACH (const location_type& l)
  {
    return symbol_type (token::FOREACH, l);
  }

  Parser::symbol_type
  Parser::make_FROM (const location_type& l)
  {
    return symbol_type (token::FROM, l);
  }

  Parser::symbol_type
  Parser::make_FUNCTION (const location_type& l)
  {
    return symbol_type (token::FUNCTION, l);
  }

  Parser::symbol_type
  Parser::make_GEQ (const location_type& l)
  {
    return symbol_type (token::GEQ, l);
  }

  Parser::symbol_type
  Parser::make_GLOBAL (const location_type& l)
  {
    return symbol_type (token::GLOBAL, l);
  }

  Parser::symbol_type
  Parser::make_HASATTR (const location_type& l)
  {
    return symbol_type (token::HASATTR, l);
  }

  Parser::symbol_type
  Parser::make_HOOK_COMPOSE (const location_type& l)
  {
    return symbol_type (token::HOOK_COMPOSE, l);
  }

  Parser::symbol_type
  Parser::make_HOOK_PARSE (const location_type& l)
  {
    return symbol_type (token::HOOK_PARSE, l);
  }

  Parser::symbol_type
  Parser::make_IF (const location_type& l)
  {
    return symbol_type (token::IF, l);
  }

  Parser::symbol_type
  Parser::make_IMPORT (const location_type& l)
  {
    return symbol_type (token::IMPORT, l);
  }

  Parser::symbol_type
  Parser::make_IN (const location_type& l)
  {
    return symbol_type (token::IN, l);
  }

  Parser::symbol_type
  Parser::make_INOUT (const location_type& l)
  {
    return symbol_type (token::INOUT, l);
  }

  Parser::symbol_type
  Parser::make_INT (const location_type& l)
  {
    return symbol_type (token::INT, l);
  }

  Parser::symbol_type
  Parser::make_INT16 (const location_type& l)
  {
    return symbol_type (token::INT16, l);
  }

  Parser::symbol_type
  Parser::make_INT32 (const location_type& l)
  {
    return symbol_type (token::INT32, l);
  }

  Parser::symbol_type
  Parser::make_INT64 (const location_type& l)
  {
    return symbol_type (token::INT64, l);
  }

  Parser::symbol_type
  Parser::make_INT8 (const location_type& l)
  {
    return symbol_type (token::INT8, l);
  }

  Parser::symbol_type
  Parser::make_INTERVAL (const location_type& l)
  {
    return symbol_type (token::INTERVAL, l);
  }

  Parser::symbol_type
  Parser::make_INTERVAL_NS (const location_type& l)
  {
    return symbol_type (token::INTERVAL_NS, l);
  }

  Parser::symbol_type
  Parser::make_ITERATOR (const location_type& l)
  {
    return symbol_type (token::ITERATOR, l);
  }

  Parser::symbol_type
  Parser::make_CONST_ITERATOR (const location_type& l)
  {
    return symbol_type (token::CONST_ITERATOR, l);
  }

  Parser::symbol_type
  Parser::make_LEQ (const location_type& l)
  {
    return symbol_type (token::LEQ, l);
  }

  Parser::symbol_type
  Parser::make_LIBRARY_TYPE (const location_type& l)
  {
    return symbol_type (token::LIBRARY_TYPE, l);
  }

  Parser::symbol_type
  Parser::make_LIST (const location_type& l)
  {
    return symbol_type (token::LIST, l);
  }

  Parser::symbol_type
  Parser::make_LOCAL (const location_type& l)
  {
    return symbol_type (token::LOCAL, l);
  }

  Parser::symbol_type
  Parser::make_MAP (const location_type& l)
  {
    return symbol_type (token::MAP, l);
  }

  Parser::symbol_type
  Parser::make_MARK (const location_type& l)
  {
    return symbol_type (token::MARK, l);
  }

  Parser::symbol_type
  Parser::make_CAPTURES (const location_type& l)
  {
    return symbol_type (token::CAPTURES, l);
  }

  Parser::symbol_type
  Parser::make_MINUSASSIGN (const location_type& l)
  {
    return symbol_type (token::MINUSASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_MINUSMINUS (const location_type& l)
  {
    return symbol_type (token::MINUSMINUS, l);
  }

  Parser::symbol_type
  Parser::make_MOD (const location_type& l)
  {
    return symbol_type (token::MOD, l);
  }

  Parser::symbol_type
  Parser::make_MODULE (const location_type& l)
  {
    return symbol_type (token::MODULE, l);
  }

  Parser::symbol_type
  Parser::make_NEQ (const location_type& l)
  {
    return symbol_type (token::NEQ, l);
  }

  Parser::symbol_type
  Parser::make_NET (const location_type& l)
  {
    return symbol_type (token::NET, l);
  }

  Parser::symbol_type
  Parser::make_NETWORK (const location_type& l)
  {
    return symbol_type (token::NETWORK, l);
  }

  Parser::symbol_type
  Parser::make_NEW (const location_type& l)
  {
    return symbol_type (token::NEW, l);
  }

  Parser::symbol_type
  Parser::make_NONE (const location_type& l)
  {
    return symbol_type (token::NONE, l);
  }

  Parser::symbol_type
  Parser::make_NOT_IN (const location_type& l)
  {
    return symbol_type (token::NOT_IN, l);
  }

  Parser::symbol_type
  Parser::make_OBJECT (const location_type& l)
  {
    return symbol_type (token::OBJECT, l);
  }

  Parser::symbol_type
  Parser::make_ON (const location_type& l)
  {
    return symbol_type (token::ON, l);
  }

  Parser::symbol_type
  Parser::make_OPTIONAL (const location_type& l)
  {
    return symbol_type (token::OPTIONAL, l);
  }

  Parser::symbol_type
  Parser::make_OR (const location_type& l)
  {
    return symbol_type (token::OR, l);
  }

  Parser::symbol_type
  Parser::make_PACK (const location_type& l)
  {
    return symbol_type (token::PACK, l);
  }

  Parser::symbol_type
  Parser::make_PLUSASSIGN (const location_type& l)
  {
    return symbol_type (token::PLUSASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_PLUSPLUS (const location_type& l)
  {
    return symbol_type (token::PLUSPLUS, l);
  }

  Parser::symbol_type
  Parser::make_PORT (const location_type& l)
  {
    return symbol_type (token::PORT, l);
  }

  Parser::symbol_type
  Parser::make_POW (const location_type& l)
  {
    return symbol_type (token::POW, l);
  }

  Parser::symbol_type
  Parser::make_PRINT (const location_type& l)
  {
    return symbol_type (token::PRINT, l);
  }

  Parser::symbol_type
  Parser::make_PRIORITY (const location_type& l)
  {
    return symbol_type (token::PRIORITY, l);
  }

  Parser::symbol_type
  Parser::make_PRIVATE (const location_type& l)
  {
    return symbol_type (token::PRIVATE, l);
  }

  Parser::symbol_type
  Parser::make_PUBLIC (const location_type& l)
  {
    return symbol_type (token::PUBLIC, l);
  }

  Parser::symbol_type
  Parser::make_REGEXP (const location_type& l)
  {
    return symbol_type (token::REGEXP, l);
  }

  Parser::symbol_type
  Parser::make_RETURN (const location_type& l)
  {
    return symbol_type (token::RETURN, l);
  }

  Parser::symbol_type
  Parser::make_SET (const location_type& l)
  {
    return symbol_type (token::SET, l);
  }

  Parser::symbol_type
  Parser::make_SHIFTLEFT (const location_type& l)
  {
    return symbol_type (token::SHIFTLEFT, l);
  }

  Parser::symbol_type
  Parser::make_SHIFTRIGHT (const location_type& l)
  {
    return symbol_type (token::SHIFTRIGHT, l);
  }

  Parser::symbol_type
  Parser::make_SINK (const location_type& l)
  {
    return symbol_type (token::SINK, l);
  }

  Parser::symbol_type
  Parser::make_SKIP (const location_type& l)
  {
    return symbol_type (token::SKIP, l);
  }

  Parser::symbol_type
  Parser::make_STOP (const location_type& l)
  {
    return symbol_type (token::STOP, l);
  }

  Parser::symbol_type
  Parser::make_STREAM (const location_type& l)
  {
    return symbol_type (token::STREAM, l);
  }

  Parser::symbol_type
  Parser::make_STRING (const location_type& l)
  {
    return symbol_type (token::STRING, l);
  }

  Parser::symbol_type
  Parser::make_STRUCT (const location_type& l)
  {
    return symbol_type (token::STRUCT, l);
  }

  Parser::symbol_type
  Parser::make_SWITCH (const location_type& l)
  {
    return symbol_type (token::SWITCH, l);
  }

  Parser::symbol_type
  Parser::make_CONFIRM (const location_type& l)
  {
    return symbol_type (token::CONFIRM, l);
  }

  Parser::symbol_type
  Parser::make_REJECT_ (const location_type& l)
  {
    return symbol_type (token::REJECT_, l);
  }

  Parser::symbol_type
  Parser::make_THROW (const location_type& l)
  {
    return symbol_type (token::THROW, l);
  }

  Parser::symbol_type
  Parser::make_TIME (const location_type& l)
  {
    return symbol_type (token::TIME, l);
  }

  Parser::symbol_type
  Parser::make_TIME_NS (const location_type& l)
  {
    return symbol_type (token::TIME_NS, l);
  }

  Parser::symbol_type
  Parser::make_TIMER (const location_type& l)
  {
    return symbol_type (token::TIMER, l);
  }

  Parser::symbol_type
  Parser::make_TIMESASSIGN (const location_type& l)
  {
    return symbol_type (token::TIMESASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_TRY (const location_type& l)
  {
    return symbol_type (token::TRY, l);
  }

  Parser::symbol_type
  Parser::make_TRYATTR (const location_type& l)
  {
    return symbol_type (token::TRYATTR, l);
  }

  Parser::symbol_type
  Parser::make_TUPLE (const location_type& l)
  {
    return symbol_type (token::TUPLE, l);
  }

  Parser::symbol_type
  Parser::make_TYPE (const location_type& l)
  {
    return symbol_type (token::TYPE, l);
  }

  Parser::symbol_type
  Parser::make_UINT (const location_type& l)
  {
    return symbol_type (token::UINT, l);
  }

  Parser::symbol_type
  Parser::make_UINT16 (const location_type& l)
  {
    return symbol_type (token::UINT16, l);
  }

  Parser::symbol_type
  Parser::make_UINT32 (const location_type& l)
  {
    return symbol_type (token::UINT32, l);
  }

  Parser::symbol_type
  Parser::make_UINT64 (const location_type& l)
  {
    return symbol_type (token::UINT64, l);
  }

  Parser::symbol_type
  Parser::make_UINT8 (const location_type& l)
  {
    return symbol_type (token::UINT8, l);
  }

  Parser::symbol_type
  Parser::make_UNIT (const location_type& l)
  {
    return symbol_type (token::UNIT, l);
  }

  Parser::symbol_type
  Parser::make_UNPACK (const location_type& l)
  {
    return symbol_type (token::UNPACK, l);
  }

  Parser::symbol_type
  Parser::make_UNSET (const location_type& l)
  {
    return symbol_type (token::UNSET, l);
  }

  Parser::symbol_type
  Parser::make_VAR (const location_type& l)
  {
    return symbol_type (token::VAR, l);
  }

  Parser::symbol_type
  Parser::make_VECTOR (const location_type& l)
  {
    return symbol_type (token::VECTOR, l);
  }

  Parser::symbol_type
  Parser::make_VIEW (const location_type& l)
  {
    return symbol_type (token::VIEW, l);
  }

  Parser::symbol_type
  Parser::make_VOID (const location_type& l)
  {
    return symbol_type (token::VOID, l);
  }

  Parser::symbol_type
  Parser::make_WHILE (const location_type& l)
  {
    return symbol_type (token::WHILE, l);
  }

  Parser::symbol_type
  Parser::make_START_MODULE (const location_type& l)
  {
    return symbol_type (token::START_MODULE, l);
  }

  Parser::symbol_type
  Parser::make_START_EXPRESSION (const location_type& l)
  {
    return symbol_type (token::START_EXPRESSION, l);
  }



  // by_state.
  inline
  Parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Parser::symbol_number_type
  Parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 19: // "bool value"
      case 255: // opt_skip
      case 257: // opt_skip_
        value.move< bool > (that.value);
        break;

      case 16: // "real value"
        value.move< double > (that.value);
        break;

      case 271: // unit_hook_attribute
      case 322: // attribute
        value.move< hilti::Attribute > (that.value);
        break;

      case 250: // unit_field_ctor
      case 300: // ctor
      case 302: // tuple
      case 307: // list
      case 308: // vector
      case 309: // set
      case 310: // map
      case 311: // struct_
      case 314: // regexp
        value.move< hilti::Ctor > (that.value);
        break;

      case 181: // global_scope_decl
      case 182: // type_decl
      case 184: // constant_decl
      case 187: // local_decl
      case 188: // local_init_decl
      case 189: // global_decl
      case 193: // function_decl
      case 196: // import_decl
      case 197: // property_decl
      case 198: // hook_decl
      case 230: // struct_field
        value.move< hilti::Declaration > (that.value);
        break;

      case 277: // expr
      case 282: // expr_0
      case 283: // expr_1
      case 284: // expr_2
      case 285: // expr_3
      case 286: // expr_4
      case 287: // expr_5
      case 288: // expr_6
      case 289: // expr_7
      case 290: // expr_8
      case 291: // expr_9
      case 292: // expr_a
      case 293: // expr_b
      case 294: // expr_c
      case 295: // expr_d
      case 296: // expr_e
      case 297: // expr_f
      case 298: // expr_g
      case 299: // member_expr
      case 301: // ctor_expr
      case 305: // tuple_elem
      case 306: // tuple_expr
        value.move< hilti::Expression > (that.value);
        break;

      case 175: // local_id
      case 176: // scoped_id
      case 177: // dotted_id
      case 268: // unit_hook_id
        value.move< hilti::ID > (that.value);
        break;

      case 209: // block
      case 210: // braced_block
      case 213: // stmt
      case 217: // stmt_decl
      case 218: // stmt_expr
        value.move< hilti::Statement > (that.value);
        break;

      case 219: // base_type_no_ref
      case 220: // reference_type
      case 221: // base_type
      case 222: // type
      case 225: // tuple_type
      case 228: // struct_type
      case 231: // enum_type
      case 234: // bitfield_type
      case 239: // unit_type
        value.move< hilti::Type > (that.value);
        break;

      case 321: // map_elem
        value.move< hilti::ctor::map::Element > (that.value);
        break;

      case 313: // struct_elem
        value.move< hilti::ctor::struct_::Field > (that.value);
        break;

      case 199: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case 207: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (that.value);
        break;

      case 201: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case 216: // switch_case
        value.move< hilti::statement::switch_::Case > (that.value);
        break;

      case 233: // enum_label
        value.move< hilti::type::enum_::Label > (that.value);
        break;

      case 200: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case 204: // func_param
        value.move< hilti::type::function::Parameter > (that.value);
        break;

      case 205: // func_result
      case 206: // opt_func_result
        value.move< hilti::type::function::Result > (that.value);
        break;

      case 227: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (that.value);
        break;

      case 248: // const_sint
        value.move< int64_t > (that.value);
        break;

      case 254: // opt_unit_field_engine
      case 272: // opt_hook_engine
        value.move< spicy::Engine > (that.value);
        break;

      case 265: // unit_hook
        value.move< spicy::Hook > (that.value);
        break;

      case 238: // bitfield_bits_spec
        value.move< spicy::type::bitfield::Bits > (that.value);
        break;

      case 243: // unit_item
      case 244: // unit_variable
      case 245: // unit_sink
      case 246: // unit_property
      case 247: // unit_field
      case 251: // unit_field_in_container
      case 252: // unit_wide_hook
      case 273: // unit_switch
        value.move< spicy::type::unit::Item > (that.value);
        break;

      case 276: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case > (that.value);
        break;

      case 267: // opt_unit_hook_attributes
      case 323: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case 208: // opt_init_expression
      case 259: // unit_field_repeat
      case 260: // opt_unit_field_repeat
      case 261: // opt_unit_field_condition
      case 274: // opt_unit_switch_expr
        value.move< std::optional<hilti::Expression> > (that.value);
        break;

      case 253: // opt_unit_field_id
        value.move< std::optional<hilti::ID> > (that.value);
        break;

      case 214: // opt_else_block
        value.move< std::optional<hilti::Statement> > (that.value);
        break;

      case 192: // global_decl_type_and_init
        value.move< std::pair<hilti::Type, std::optional<hilti::Expression>> > (that.value);
        break;

      case 180: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 316: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case 229: // struct_fields
        value.move< std::vector<hilti::Declaration> > (that.value);
        break;

      case 258: // opt_unit_field_args
      case 262: // opt_unit_field_sinks
      case 280: // opt_exprs
      case 281: // exprs
      case 303: // opt_tuple_elems1
      case 304: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (that.value);
        break;

      case 211: // opt_stmts
      case 212: // stmts
        value.move< std::vector<hilti::Statement> > (that.value);
        break;

      case 319: // opt_map_elems
      case 320: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case 312: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case 215: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case 232: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case 202: // opt_func_params
      case 203: // func_params
      case 240: // opt_unit_params
      case 266: // opt_unit_hook_params
        value.move< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case 226: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case 263: // opt_unit_item_hooks
      case 264: // unit_hooks
        value.move< std::vector<spicy::Hook> > (that.value);
        break;

      case 236: // opt_bitfield_bits
      case 237: // bitfield_bits
        value.move< std::vector<spicy::type::bitfield::Bits> > (that.value);
        break;

      case 241: // unit_items
      case 242: // opt_unit_items
        value.move< std::vector<spicy::type::unit::Item> > (that.value);
        break;

      case 275: // unit_switch_cases
        value.move< std::vector<spicy::type::unit::item::switch_::Case> > (that.value);
        break;

      case 315: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 249: // const_uint
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 19: // "bool value"
      case 255: // opt_skip
      case 257: // opt_skip_
        value.copy< bool > (that.value);
        break;

      case 16: // "real value"
        value.copy< double > (that.value);
        break;

      case 271: // unit_hook_attribute
      case 322: // attribute
        value.copy< hilti::Attribute > (that.value);
        break;

      case 250: // unit_field_ctor
      case 300: // ctor
      case 302: // tuple
      case 307: // list
      case 308: // vector
      case 309: // set
      case 310: // map
      case 311: // struct_
      case 314: // regexp
        value.copy< hilti::Ctor > (that.value);
        break;

      case 181: // global_scope_decl
      case 182: // type_decl
      case 184: // constant_decl
      case 187: // local_decl
      case 188: // local_init_decl
      case 189: // global_decl
      case 193: // function_decl
      case 196: // import_decl
      case 197: // property_decl
      case 198: // hook_decl
      case 230: // struct_field
        value.copy< hilti::Declaration > (that.value);
        break;

      case 277: // expr
      case 282: // expr_0
      case 283: // expr_1
      case 284: // expr_2
      case 285: // expr_3
      case 286: // expr_4
      case 287: // expr_5
      case 288: // expr_6
      case 289: // expr_7
      case 290: // expr_8
      case 291: // expr_9
      case 292: // expr_a
      case 293: // expr_b
      case 294: // expr_c
      case 295: // expr_d
      case 296: // expr_e
      case 297: // expr_f
      case 298: // expr_g
      case 299: // member_expr
      case 301: // ctor_expr
      case 305: // tuple_elem
      case 306: // tuple_expr
        value.copy< hilti::Expression > (that.value);
        break;

      case 175: // local_id
      case 176: // scoped_id
      case 177: // dotted_id
      case 268: // unit_hook_id
        value.copy< hilti::ID > (that.value);
        break;

      case 209: // block
      case 210: // braced_block
      case 213: // stmt
      case 217: // stmt_decl
      case 218: // stmt_expr
        value.copy< hilti::Statement > (that.value);
        break;

      case 219: // base_type_no_ref
      case 220: // reference_type
      case 221: // base_type
      case 222: // type
      case 225: // tuple_type
      case 228: // struct_type
      case 231: // enum_type
      case 234: // bitfield_type
      case 239: // unit_type
        value.copy< hilti::Type > (that.value);
        break;

      case 321: // map_elem
        value.copy< hilti::ctor::map::Element > (that.value);
        break;

      case 313: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (that.value);
        break;

      case 199: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case 207: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (that.value);
        break;

      case 201: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case 216: // switch_case
        value.copy< hilti::statement::switch_::Case > (that.value);
        break;

      case 233: // enum_label
        value.copy< hilti::type::enum_::Label > (that.value);
        break;

      case 200: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case 204: // func_param
        value.copy< hilti::type::function::Parameter > (that.value);
        break;

      case 205: // func_result
      case 206: // opt_func_result
        value.copy< hilti::type::function::Result > (that.value);
        break;

      case 227: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (that.value);
        break;

      case 248: // const_sint
        value.copy< int64_t > (that.value);
        break;

      case 254: // opt_unit_field_engine
      case 272: // opt_hook_engine
        value.copy< spicy::Engine > (that.value);
        break;

      case 265: // unit_hook
        value.copy< spicy::Hook > (that.value);
        break;

      case 238: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (that.value);
        break;

      case 243: // unit_item
      case 244: // unit_variable
      case 245: // unit_sink
      case 246: // unit_property
      case 247: // unit_field
      case 251: // unit_field_in_container
      case 252: // unit_wide_hook
      case 273: // unit_switch
        value.copy< spicy::type::unit::Item > (that.value);
        break;

      case 276: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (that.value);
        break;

      case 267: // opt_unit_hook_attributes
      case 323: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case 208: // opt_init_expression
      case 259: // unit_field_repeat
      case 260: // opt_unit_field_repeat
      case 261: // opt_unit_field_condition
      case 274: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (that.value);
        break;

      case 253: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (that.value);
        break;

      case 214: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (that.value);
        break;

      case 192: // global_decl_type_and_init
        value.copy< std::pair<hilti::Type, std::optional<hilti::Expression>> > (that.value);
        break;

      case 180: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 316: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case 229: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (that.value);
        break;

      case 258: // opt_unit_field_args
      case 262: // opt_unit_field_sinks
      case 280: // opt_exprs
      case 281: // exprs
      case 303: // opt_tuple_elems1
      case 304: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (that.value);
        break;

      case 211: // opt_stmts
      case 212: // stmts
        value.copy< std::vector<hilti::Statement> > (that.value);
        break;

      case 319: // opt_map_elems
      case 320: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case 312: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case 215: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case 232: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case 202: // opt_func_params
      case 203: // func_params
      case 240: // opt_unit_params
      case 266: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case 226: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case 263: // opt_unit_item_hooks
      case 264: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (that.value);
        break;

      case 236: // opt_bitfield_bits
      case 237: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (that.value);
        break;

      case 241: // unit_items
      case 242: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (that.value);
        break;

      case 275: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (that.value);
        break;

      case 315: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 249: // const_uint
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  Parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    // User initialization code.
    #line 20 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:741
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
    yyla.location.begin.line = yyla.location.end.line = driver->currentLine();
}

#line 3578 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:741

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 19: // "bool value"
      case 255: // opt_skip
      case 257: // opt_skip_
        yylhs.value.build< bool > ();
        break;

      case 16: // "real value"
        yylhs.value.build< double > ();
        break;

      case 271: // unit_hook_attribute
      case 322: // attribute
        yylhs.value.build< hilti::Attribute > ();
        break;

      case 250: // unit_field_ctor
      case 300: // ctor
      case 302: // tuple
      case 307: // list
      case 308: // vector
      case 309: // set
      case 310: // map
      case 311: // struct_
      case 314: // regexp
        yylhs.value.build< hilti::Ctor > ();
        break;

      case 181: // global_scope_decl
      case 182: // type_decl
      case 184: // constant_decl
      case 187: // local_decl
      case 188: // local_init_decl
      case 189: // global_decl
      case 193: // function_decl
      case 196: // import_decl
      case 197: // property_decl
      case 198: // hook_decl
      case 230: // struct_field
        yylhs.value.build< hilti::Declaration > ();
        break;

      case 277: // expr
      case 282: // expr_0
      case 283: // expr_1
      case 284: // expr_2
      case 285: // expr_3
      case 286: // expr_4
      case 287: // expr_5
      case 288: // expr_6
      case 289: // expr_7
      case 290: // expr_8
      case 291: // expr_9
      case 292: // expr_a
      case 293: // expr_b
      case 294: // expr_c
      case 295: // expr_d
      case 296: // expr_e
      case 297: // expr_f
      case 298: // expr_g
      case 299: // member_expr
      case 301: // ctor_expr
      case 305: // tuple_elem
      case 306: // tuple_expr
        yylhs.value.build< hilti::Expression > ();
        break;

      case 175: // local_id
      case 176: // scoped_id
      case 177: // dotted_id
      case 268: // unit_hook_id
        yylhs.value.build< hilti::ID > ();
        break;

      case 209: // block
      case 210: // braced_block
      case 213: // stmt
      case 217: // stmt_decl
      case 218: // stmt_expr
        yylhs.value.build< hilti::Statement > ();
        break;

      case 219: // base_type_no_ref
      case 220: // reference_type
      case 221: // base_type
      case 222: // type
      case 225: // tuple_type
      case 228: // struct_type
      case 231: // enum_type
      case 234: // bitfield_type
      case 239: // unit_type
        yylhs.value.build< hilti::Type > ();
        break;

      case 321: // map_elem
        yylhs.value.build< hilti::ctor::map::Element > ();
        break;

      case 313: // struct_elem
        yylhs.value.build< hilti::ctor::struct_::Field > ();
        break;

      case 199: // opt_linkage
        yylhs.value.build< hilti::declaration::Linkage > ();
        break;

      case 207: // opt_func_param_kind
        yylhs.value.build< hilti::declaration::parameter::Kind > ();
        break;

      case 201: // opt_func_cc
        yylhs.value.build< hilti::function::CallingConvention > ();
        break;

      case 216: // switch_case
        yylhs.value.build< hilti::statement::switch_::Case > ();
        break;

      case 233: // enum_label
        yylhs.value.build< hilti::type::enum_::Label > ();
        break;

      case 200: // opt_func_flavor
        yylhs.value.build< hilti::type::function::Flavor > ();
        break;

      case 204: // func_param
        yylhs.value.build< hilti::type::function::Parameter > ();
        break;

      case 205: // func_result
      case 206: // opt_func_result
        yylhs.value.build< hilti::type::function::Result > ();
        break;

      case 227: // tuple_type_elem
        yylhs.value.build< hilti::type::tuple::Element > ();
        break;

      case 248: // const_sint
        yylhs.value.build< int64_t > ();
        break;

      case 254: // opt_unit_field_engine
      case 272: // opt_hook_engine
        yylhs.value.build< spicy::Engine > ();
        break;

      case 265: // unit_hook
        yylhs.value.build< spicy::Hook > ();
        break;

      case 238: // bitfield_bits_spec
        yylhs.value.build< spicy::type::bitfield::Bits > ();
        break;

      case 243: // unit_item
      case 244: // unit_variable
      case 245: // unit_sink
      case 246: // unit_property
      case 247: // unit_field
      case 251: // unit_field_in_container
      case 252: // unit_wide_hook
      case 273: // unit_switch
        yylhs.value.build< spicy::type::unit::Item > ();
        break;

      case 276: // unit_switch_case
        yylhs.value.build< spicy::type::unit::item::switch_::Case > ();
        break;

      case 267: // opt_unit_hook_attributes
      case 323: // opt_attributes
        yylhs.value.build< std::optional<hilti::AttributeSet> > ();
        break;

      case 208: // opt_init_expression
      case 259: // unit_field_repeat
      case 260: // opt_unit_field_repeat
      case 261: // opt_unit_field_condition
      case 274: // opt_unit_switch_expr
        yylhs.value.build< std::optional<hilti::Expression> > ();
        break;

      case 253: // opt_unit_field_id
        yylhs.value.build< std::optional<hilti::ID> > ();
        break;

      case 214: // opt_else_block
        yylhs.value.build< std::optional<hilti::Statement> > ();
        break;

      case 192: // global_decl_type_and_init
        yylhs.value.build< std::pair<hilti::Type, std::optional<hilti::Expression>> > ();
        break;

      case 180: // global_scope_items
        yylhs.value.build< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 316: // re_pattern_constant
        yylhs.value.build< std::string > ();
        break;

      case 229: // struct_fields
        yylhs.value.build< std::vector<hilti::Declaration> > ();
        break;

      case 258: // opt_unit_field_args
      case 262: // opt_unit_field_sinks
      case 280: // opt_exprs
      case 281: // exprs
      case 303: // opt_tuple_elems1
      case 304: // opt_tuple_elems2
        yylhs.value.build< std::vector<hilti::Expression> > ();
        break;

      case 211: // opt_stmts
      case 212: // stmts
        yylhs.value.build< std::vector<hilti::Statement> > ();
        break;

      case 319: // opt_map_elems
      case 320: // map_elems
        yylhs.value.build< std::vector<hilti::ctor::map::Element> > ();
        break;

      case 312: // struct_elems
        yylhs.value.build< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case 215: // switch_cases
        yylhs.value.build< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case 232: // enum_labels
        yylhs.value.build< std::vector<hilti::type::enum_::Label> > ();
        break;

      case 202: // opt_func_params
      case 203: // func_params
      case 240: // opt_unit_params
      case 266: // opt_unit_hook_params
        yylhs.value.build< std::vector<hilti::type::function::Parameter> > ();
        break;

      case 226: // tuple_type_elems
        yylhs.value.build< std::vector<hilti::type::tuple::Element> > ();
        break;

      case 263: // opt_unit_item_hooks
      case 264: // unit_hooks
        yylhs.value.build< std::vector<spicy::Hook> > ();
        break;

      case 236: // opt_bitfield_bits
      case 237: // bitfield_bits
        yylhs.value.build< std::vector<spicy::type::bitfield::Bits> > ();
        break;

      case 241: // unit_items
      case 242: // opt_unit_items
        yylhs.value.build< std::vector<spicy::type::unit::Item> > ();
        break;

      case 275: // unit_switch_cases
        yylhs.value.build< std::vector<spicy::type::unit::item::switch_::Case> > ();
        break;

      case 315: // re_patterns
        yylhs.value.build< std::vector<std::string> > ();
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 249: // const_uint
        yylhs.value.build< uint64_t > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 4:
#line 315 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->setDestinationExpression(std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 3978 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 5:
#line 317 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 3984 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 318 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto m = hilti::Module(yystack_[3].value.as< hilti::ID > (), std::move(yystack_[0].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first), std::move(yystack_[0].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second), __loc__);
                                                   m.setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                   driver->setDestinationModule(m);
                                                 }
#line 3994 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 7:
#line 327 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { std::string name(yystack_[0].value.as< std::string > ());

                                                   if ( name.find('-') != std::string::npos)
                                                       hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                   if ( name.substr(0, 2) == "__" )
                                                       hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());

                                                   yylhs.value.as< hilti::ID > () = hilti::ID(std::move(name), __loc__);
                                                 }
#line 4008 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 337 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = std::move(yystack_[0].value.as< hilti::ID > ()); }
#line 4014 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 9:
#line 338 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[0].value.as< std::string > (), __loc__); }
#line 4020 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 340 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableDottedIDMode(); }
#line 4026 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 11:
#line 342 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableDottedIDMode(); }
#line 4032 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 342 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[1].value.as< std::string > (), __loc__); }
#line 4038 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 13:
#line 348 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first.push_back(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4044 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 350 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second.push_back(yystack_[0].value.as< hilti::Statement > ()); }
#line 4050 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 15:
#line 351 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = {}; }
#line 4056 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 355 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4062 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 17:
#line 356 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4068 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 357 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4074 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 19:
#line 358 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4080 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 359 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4086 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 21:
#line 360 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4092 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 361 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4098 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 23:
#line 363 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 4104 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 364 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { if ( auto x = yystack_[2].value.as< hilti::Type > ().isA<type::Unit>(); x && yystack_[1].value.as< std::optional<hilti::AttributeSet> > () && *yystack_[1].value.as< std::optional<hilti::AttributeSet> > () ) {
                                                       yystack_[2].value.as< hilti::Type > ().as<type::Unit>().setAttributes(*yystack_[1].value.as< std::optional<hilti::AttributeSet> > ());
                                                       yystack_[1].value.as< std::optional<hilti::AttributeSet> > () = {}; // don't associate with declaration
                                                       }

                                                   yylhs.value.as< hilti::Declaration > () = hilti::declaration::Type(std::move(yystack_[5].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[7].value.as< hilti::declaration::Linkage > ()), __loc__);
                                                   yylhs.value.as< hilti::Declaration > ().setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 4118 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 25:
#line 374 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 4124 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 375 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Constant(yystack_[4].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), yystack_[6].value.as< hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as< hilti::Declaration > ().setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 4133 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 380 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 4139 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 381 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Constant(yystack_[6].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), yystack_[8].value.as< hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as< hilti::Declaration > ().setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 4148 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 387 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), false, __loc__); }
#line 4154 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 388 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Type > (), {}, false, __loc__); }
#line 4160 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 390 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[5].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), false, __loc__); }
#line 4166 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 395 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[4].value.as< hilti::ID > (), yystack_[2].value.as< hilti::Type > (), yystack_[0].value.as< hilti::Expression > (), false, __loc__); }
#line 4172 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 397 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as< hilti::ID > (), yystack_[0].value.as< hilti::Expression > (), false, __loc__); }
#line 4178 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 400 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 4184 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 401 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[4].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), yystack_[6].value.as< hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as< hilti::Declaration > ().setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 4193 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 406 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 4199 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 37:
#line 407 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[0].value.as< std::pair<hilti::Type, std::optional<hilti::Expression>> > ().first, yystack_[0].value.as< std::pair<hilti::Type, std::optional<hilti::Expression>> > ().second, yystack_[5].value.as< hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as< hilti::Declaration > ().setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 4208 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 38:
#line 414 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<hilti::Type, std::optional<hilti::Expression>> > () = std::make_pair(yystack_[1].value.as< hilti::Type > (), std::nullopt); }
#line 4214 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 415 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<hilti::Type, std::optional<hilti::Expression>> > () = std::make_pair(yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > ()); }
#line 4220 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 418 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 4226 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 419 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[3].value.as< hilti::type::function::Result > (), yystack_[5].value.as< std::vector<hilti::type::function::Parameter> > (), yystack_[9].value.as< hilti::type::function::Flavor > (), __loc__);
                                                    auto func = hilti::Function(yystack_[7].value.as< hilti::ID > (), std::move(ftype), {}, yystack_[8].value.as< hilti::function::CallingConvention > (), yystack_[2].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                    yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(std::move(func), yystack_[11].value.as< hilti::declaration::Linkage > (), __loc__);
                                                    yylhs.value.as< hilti::Declaration > ().setDocumentation(_docs.back());
                                                    _docs.pop_back();
                                                 }
#line 4238 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 428 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _docs.emplace_back(driver->docGetAndClear()); }
#line 4244 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 43:
#line 429 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[3].value.as< hilti::type::function::Result > (), yystack_[5].value.as< std::vector<hilti::type::function::Parameter> > (), yystack_[9].value.as< hilti::type::function::Flavor > (), __loc__);
                                                    auto func = hilti::Function(yystack_[7].value.as< hilti::ID > (), std::move(ftype), yystack_[0].value.as< hilti::Statement > (), yystack_[8].value.as< hilti::function::CallingConvention > (), yystack_[2].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                    yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(std::move(func), yystack_[11].value.as< hilti::declaration::Linkage > (), __loc__);
                                                    yylhs.value.as< hilti::Declaration > ().setDocumentation(_docs.back());
                                                    _docs.pop_back();
                                                 }
#line 4256 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 44:
#line 438 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[1].value.as< hilti::ID > ()), std::string(".spicy"), __loc__); }
#line 4262 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 439 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[3].value.as< hilti::ID > ()), std::string(".spicy"), std::move(yystack_[1].value.as< hilti::ID > ()), __loc__); }
#line 4268 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 442 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[1].value.as< std::string > ())), __loc__); }
#line 4274 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 443 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as< std::string > ())), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4280 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 444 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as< std::string > ())), hilti::expression::Type_(std::move(yystack_[1].value.as< hilti::Type > ())), __loc__); }
#line 4286 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 49:
#line 447 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { ID unit = yystack_[1].value.as< hilti::ID > ().namespace_();
                                                   if ( unit.empty() )
                                                      error(yylhs.location, "hook requires unit namespace");

                                                   yylhs.value.as< hilti::Declaration > () = spicy::declaration::UnitHook(std::move(yystack_[1].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< spicy::Hook > ()), __loc__);
                                                 }
#line 4297 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 50:
#line 455 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 4303 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 456 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 4309 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 457 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 4315 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 461 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 4321 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 463 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try {
                                                       yylhs.value.as< hilti::function::CallingConvention > () = hilti::function::calling_convention::from_string(yystack_[0].value.as< std::string > ());
                                                   } catch ( std::out_of_range& e ) {
                                                       error(yylhs.location, "unknown calling convention");
                                                   }
                                                 }
#line 4332 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 55:
#line 469 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 4338 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 56:
#line 473 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[0].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 4344 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 57:
#line 474 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 4350 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 58:
#line 476 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::function::Parameter> > ()); yylhs.value.as< std::vector<hilti::type::function::Parameter> > ().push_back(yystack_[0].value.as< hilti::type::function::Parameter > ()); }
#line 4356 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 59:
#line 477 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{yystack_[0].value.as< hilti::type::function::Parameter > ()}; }
#line 4362 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 60:
#line 480 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Parameter > () = hilti::type::function::Parameter(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Type > (), yystack_[4].value.as< hilti::declaration::parameter::Kind > (), yystack_[0].value.as< std::optional<hilti::Expression> > (), __loc__); }
#line 4368 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 61:
#line 482 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Result > () = hilti::type::function::Result(std::move(yystack_[0].value.as< hilti::Type > ()), __loc__); }
#line 4374 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 62:
#line 484 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Result > () = std::move(yystack_[0].value.as< hilti::type::function::Result > ()); }
#line 4380 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 63:
#line 485 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Result > () = hilti::type::function::Result(hilti::type::void_, __loc__); }
#line 4386 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 488 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::InOut; }
#line 4392 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 489 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::In; }
#line 4398 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 66:
#line 492 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4404 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 67:
#line 493 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 4410 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 68:
#line 498 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4416 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 69:
#line 499 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Block({yystack_[0].value.as< hilti::Statement > ()}, __loc__); }
#line 4422 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 70:
#line 502 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Block(std::move(yystack_[1].value.as< std::vector<hilti::Statement> > ()), __loc__); }
#line 4428 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 71:
#line 504 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::move(yystack_[0].value.as< std::vector<hilti::Statement> > ()); }
#line 4434 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 72:
#line 505 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{}; }
#line 4440 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 73:
#line 507 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::move(yystack_[1].value.as< std::vector<hilti::Statement> > ()); yylhs.value.as< std::vector<hilti::Statement> > ().push_back(yystack_[0].value.as< hilti::Statement > ()); }
#line 4446 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 74:
#line 508 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{std::move(yystack_[0].value.as< hilti::Statement > ())}; }
#line 4452 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 75:
#line 510 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[1].value.as< hilti::Statement > ()); }
#line 4458 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 76:
#line 511 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4464 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 77:
#line 512 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[1].value.as< hilti::Expression > ()), {}, __loc__); }
#line 4470 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 78:
#line 513 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4476 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 79:
#line 514 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as< hilti::Expression > ()), {}, {}, __loc__); }
#line 4482 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 80:
#line 516 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as< hilti::Expression > ()), {}, std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4488 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 81:
#line 517 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Break(__loc__); }
#line 4494 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 82:
#line 518 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Continue(__loc__); }
#line 4500 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 83:
#line 520 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::For(std::move(yystack_[4].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4506 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 84:
#line 522 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4512 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 85:
#line 524 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as< hilti::Declaration > ()), {}, std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4518 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 86:
#line 526 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[5].value.as< hilti::Declaration > ()), std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4524 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 87:
#line 527 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Print(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 4530 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 88:
#line 528 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Return(__loc__); }
#line 4536 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 89:
#line 529 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Return(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4542 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 90:
#line 530 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Stop(__loc__); }
#line 4548 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 91:
#line 531 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Throw(hilti::builder::exception(hilti::builder::typeByID("spicy_rt::ParseError"), yystack_[1].value.as< hilti::Expression > (), __loc__), __loc__); }
#line 4554 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 533 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 4560 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 535 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as< hilti::Declaration > ()), std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 4566 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 536 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Confirm(__loc__); }
#line 4572 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 537 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Reject(__loc__); }
#line 4578 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 539 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[4].value.as< hilti::Declaration > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), std::nullopt, __loc__); }
#line 4584 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 541 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), std::nullopt, __loc__); }
#line 4590 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 543 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[2].value.as< hilti::Declaration > ()), {}, std::move(yystack_[0].value.as< hilti::Statement > ()), std::nullopt, __loc__); }
#line 4596 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 545 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4608 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 100:
#line 553 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4620 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 101:
#line 561 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4632 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 102:
#line 572 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Statement> > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4638 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 103:
#line 573 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Statement> > () = {}; }
#line 4644 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 104:
#line 575 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()); yylhs.value.as< std::vector<hilti::statement::switch_::Case> > ().push_back(std::move(yystack_[0].value.as< hilti::statement::switch_::Case > ())); }
#line 4650 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 576 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = std::vector<hilti::statement::switch_::Case>({ std::move(yystack_[0].value.as< hilti::statement::switch_::Case > ()) }); }
#line 4656 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 578 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4662 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 579 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4668 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 581 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4674 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 109:
#line 582 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4680 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 110:
#line 583 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4686 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 586 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(yystack_[0].value.as< hilti::Expression > (), __loc__); }
#line 4692 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 112:
#line 591 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Any(__loc__); }
#line 4698 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 113:
#line 592 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Address(__loc__); }
#line 4704 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 114:
#line 593 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Bool(__loc__); }
#line 4710 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 115:
#line 594 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Bytes(__loc__); }
#line 4716 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 116:
#line 595 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Interval(__loc__); }
#line 4722 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 117:
#line 596 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Network(__loc__); }
#line 4728 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 118:
#line 597 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Port(__loc__); }
#line 4734 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 119:
#line 598 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Real(__loc__); }
#line 4740 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 120:
#line 599 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::RegExp(__loc__); }
#line 4746 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 121:
#line 600 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Stream(__loc__); }
#line 4752 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 122:
#line 601 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::String(__loc__); }
#line 4758 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 123:
#line 602 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Time(__loc__); }
#line 4764 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 124:
#line 603 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::void_; }
#line 4770 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 125:
#line 605 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(8, __loc__); }
#line 4776 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 126:
#line 606 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(16, __loc__); }
#line 4782 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 127:
#line 607 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(32, __loc__); }
#line 4788 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 128:
#line 608 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(64, __loc__); }
#line 4794 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 129:
#line 609 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(8, __loc__); }
#line 4800 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 130:
#line 610 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(16, __loc__); }
#line 4806 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 131:
#line 611 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(32, __loc__); }
#line 4812 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 132:
#line 612 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(64, __loc__); }
#line 4818 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 614 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as< hilti::Type > ()), true, __loc__); }
#line 4824 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 615 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as< hilti::Type > ()), false, __loc__); }
#line 4830 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 616 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Optional(yystack_[1].value.as< hilti::Type > (), __loc__); }
#line 4836 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 617 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = viewForType(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4842 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 619 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Map(std::move(yystack_[3].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4848 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 620 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Set(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4854 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 621 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Vector(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4860 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 140:
#line 623 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = spicy::type::Sink(__loc__); }
#line 4866 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 141:
#line 625 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Library(std::move(yystack_[1].value.as< std::string > ()), __loc__); }
#line 4872 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 627 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4878 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 628 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4884 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 144:
#line 629 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4890 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 145:
#line 630 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4896 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 631 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4902 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 636 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::StrongReference(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4908 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 638 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4914 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 639 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::StrongReference(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4920 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 642 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4926 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 643 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4932 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 644 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ())); }
#line 4938 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 153:
#line 649 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableExpressionMode(); }
#line 4944 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 154:
#line 653 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableExpressionMode(); }
#line 4950 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 155:
#line 655 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Tuple(hilti::type::Wildcard(), __loc__); }
#line 4956 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 156:
#line 656 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::type::tuple::Element> > ()), __loc__); }
#line 4962 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 157:
#line 661 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::tuple::Element> > ()); yylhs.value.as< std::vector<hilti::type::tuple::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::type::tuple::Element > ())); }
#line 4968 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 158:
#line 662 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::tuple::Element> > ()); }
#line 4974 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 159:
#line 663 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::vector<type::tuple::Element>{ std::move(yystack_[0].value.as< hilti::type::tuple::Element > ()) }; }
#line 4980 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 160:
#line 667 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::tuple::Element > () = type::tuple::Element(std::move(yystack_[0].value.as< hilti::Type > ())); }
#line 4986 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 161:
#line 668 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::tuple::Element > () = type::tuple::Element(std::move(yystack_[2].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< hilti::Type > ())); }
#line 4992 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 162:
#line 671 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Struct(std::move(yystack_[1].value.as< std::vector<hilti::Declaration> > ()), __loc__); }
#line 4998 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 163:
#line 673 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::move(yystack_[1].value.as< std::vector<hilti::Declaration> > ()); yylhs.value.as< std::vector<hilti::Declaration> > ().push_back(yystack_[0].value.as< hilti::Declaration > ()); }
#line 5004 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 164:
#line 674 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::vector<Declaration>{}; }
#line 5010 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 165:
#line 676 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[4].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5016 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 678 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Enum(std::move(yystack_[1].value.as< std::vector<hilti::type::enum_::Label> > ()), __loc__); }
#line 5022 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 680 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::enum_::Label> > ()); yylhs.value.as< std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as< hilti::type::enum_::Label > ())); }
#line 5028 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 681 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::enum_::Label> > ()); }
#line 5034 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 682 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::vector<hilti::type::enum_::Label>(); yylhs.value.as< std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as< hilti::type::enum_::Label > ())); }
#line 5040 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 170:
#line 685 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 5046 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 171:
#line 686 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[2].value.as< hilti::ID > ()), yystack_[0].value.as< uint64_t > (), __loc__); }
#line 5052 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 172:
#line 690 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _field_width = yystack_[1].value.as< uint64_t > (); }
#line 5058 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 173:
#line 692 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = spicy::type::Bitfield(yystack_[5].value.as< uint64_t > (), yystack_[1].value.as< std::vector<spicy::type::bitfield::Bits> > (), __loc__); }
#line 5064 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 174:
#line 696 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::move(yystack_[0].value.as< std::vector<spicy::type::bitfield::Bits> > ()); }
#line 5070 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 175:
#line 697 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::vector<spicy::type::bitfield::Bits>(); }
#line 5076 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 176:
#line 701 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::move(yystack_[1].value.as< std::vector<spicy::type::bitfield::Bits> > ()); yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > ().push_back(std::move(yystack_[0].value.as< spicy::type::bitfield::Bits > ()));  }
#line 5082 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 702 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::vector<spicy::type::bitfield::Bits>(); yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > ().push_back(std::move(yystack_[0].value.as< spicy::type::bitfield::Bits > ())); }
#line 5088 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 178:
#line 706 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::bitfield::Bits > () = spicy::type::bitfield::Bits(std::move(yystack_[6].value.as< hilti::ID > ()), yystack_[4].value.as< uint64_t > (), yystack_[2].value.as< uint64_t > (), _field_width, std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5094 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 179:
#line 708 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::bitfield::Bits > () = spicy::type::bitfield::Bits(std::move(yystack_[4].value.as< hilti::ID > ()), yystack_[2].value.as< uint64_t > (), yystack_[2].value.as< uint64_t > (), _field_width, std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5100 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 180:
#line 713 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = spicy::type::Unit(std::move(yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[1].value.as< std::vector<spicy::type::unit::Item> > ()), {}, __loc__); }
#line 5106 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 181:
#line 716 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 5112 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 182:
#line 717 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 5118 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 183:
#line 719 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::move(yystack_[1].value.as< std::vector<spicy::type::unit::Item> > ()); yylhs.value.as< std::vector<spicy::type::unit::Item> > ().push_back(std::move(yystack_[0].value.as< spicy::type::unit::Item > ())); }
#line 5124 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 184:
#line 720 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::vector<spicy::type::unit::Item>(); yylhs.value.as< std::vector<spicy::type::unit::Item> > ().push_back(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5130 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 185:
#line 722 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::move(yystack_[0].value.as< std::vector<spicy::type::unit::Item> > ());}
#line 5136 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 186:
#line 723 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::vector<spicy::type::unit::Item>{}; }
#line 5142 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 187:
#line 726 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5148 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 188:
#line 727 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5154 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 189:
#line 728 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5160 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 190:
#line 729 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5166 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 191:
#line 730 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5172 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 192:
#line 731 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5178 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 193:
#line 736 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::Variable(std::move(yystack_[5].value.as< hilti::ID > ()), std::move(yystack_[3].value.as< hilti::Type > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5184 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 194:
#line 738 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::Sink(std::move(yystack_[2].value.as< hilti::ID > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5190 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 195:
#line 740 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[2].value.as< std::string > ())), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), false, __loc__); }
#line 5196 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 196:
#line 742 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[4].value.as< std::string > ())), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), false, __loc__); }
#line 5202 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 197:
#line 743 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[3].value.as< std::string > ())), hilti::expression::Type_(std::move(yystack_[1].value.as< hilti::Type > ())), {}, false, __loc__); }
#line 5208 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 198:
#line 747 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {   if ( yystack_[5].value.as< hilti::Type > ().isA<type::Vector>() )
                                                         error(yylhs.location, "vector<T> syntax is no longer supported for parsing sequences; use T[] instead.");
                                                     yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[8].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[5].value.as< hilti::Type > ()), std::move(yystack_[7].value.as< spicy::Engine > ()), yystack_[6].value.as< bool > (), {}, std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__);
                                                 }
#line 5217 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 199:
#line 753 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[8].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[5].value.as< hilti::Ctor > ()), std::move(yystack_[7].value.as< spicy::Engine > ()), yystack_[6].value.as< bool > (), {}, std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__); }
#line 5223 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 200:
#line 756 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[9].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[6].value.as< hilti::ID > ()), std::move(yystack_[8].value.as< spicy::Engine > ()), yystack_[7].value.as< bool > (), std::move(yystack_[5].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__); }
#line 5229 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 201:
#line 758 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[10].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[6].value.as< spicy::type::unit::Item > ()), std::move(yystack_[9].value.as< spicy::Engine > ()), yystack_[8].value.as< bool > (), {}, std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__); }
#line 5235 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 202:
#line 760 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__); }
#line 5241 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 203:
#line 761 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__); }
#line 5247 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 204:
#line 762 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = -check_int64_range(yystack_[0].value.as< uint64_t > (), false, __loc__); }
#line 5253 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 205:
#line 764 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< uint64_t > () = yystack_[0].value.as< uint64_t > (); }
#line 5259 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 206:
#line 765 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< uint64_t > () = yystack_[0].value.as< uint64_t > (); }
#line 5265 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 207:
#line 768 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 5271 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 208:
#line 769 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 8, __loc__); }
#line 5277 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 209:
#line 770 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 16, __loc__); }
#line 5283 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 210:
#line 771 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 32, __loc__); }
#line 5289 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 211:
#line 772 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 64, __loc__); }
#line 5295 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 212:
#line 773 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 8, __loc__); }
#line 5301 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 213:
#line 774 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 16, __loc__); }
#line 5307 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 214:
#line 775 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 32, __loc__); }
#line 5313 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 215:
#line 776 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 64, __loc__); }
#line 5319 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 216:
#line 780 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[2].value.as< hilti::Ctor > ()), {}, false, std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), {}, {}, std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 5325 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 217:
#line 782 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[3].value.as< hilti::ID > ()), {}, false, std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::optional<hilti::Expression> > ()), {}, std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 5331 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 218:
#line 784 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[3].value.as< hilti::Type > ()), {}, false, std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), {}, std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 5337 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 219:
#line 786 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnitHook(std::move(yystack_[1].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< spicy::Hook > ()), __loc__); }
#line 5343 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 220:
#line 789 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::ID> > () = std::move(yystack_[0].value.as< hilti::ID > ()); }
#line 5349 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 221:
#line 790 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::ID> > () = std::nullopt; }
#line 5355 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 222:
#line 793 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::All; }
#line 5361 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 223:
#line 794 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Parser; }
#line 5367 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 224:
#line 795 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Composer; }
#line 5373 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 225:
#line 796 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::All; }
#line 5379 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 226:
#line 799 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableNewKeywordMode(); }
#line 5385 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 227:
#line 801 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableNewKeywordMode(); yylhs.value.as< bool > () = yystack_[0].value.as< bool > (); }
#line 5391 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 228:
#line 804 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< bool > () = true; }
#line 5397 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 229:
#line 805 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< bool > () = false; }
#line 5403 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 230:
#line 808 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()); }
#line 5409 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 231:
#line 809 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 5415 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 232:
#line 812 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5421 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 233:
#line 813 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = hilti::builder::null(); }
#line 5427 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 234:
#line 816 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as< std::optional<hilti::Expression> > ()); }
#line 5433 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 235:
#line 817 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 5439 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 236:
#line 820 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5445 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 237:
#line 821 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 5451 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 238:
#line 824 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as< std::vector<hilti::Expression> > ()); }
#line 5457 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 239:
#line 825 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 5463 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 240:
#line 828 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()); }
#line 5469 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 241:
#line 829 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::vector<spicy::Hook>(); }
#line 5475 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 242:
#line 831 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::move(yystack_[1].value.as< std::vector<spicy::Hook> > ()); yylhs.value.as< std::vector<spicy::Hook> > ().push_back(std::move(yystack_[0].value.as< spicy::Hook > ())); }
#line 5481 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 243:
#line 832 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::vector<spicy::Hook>{std::move(yystack_[0].value.as< spicy::Hook > ())}; }
#line 5487 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 244:
#line 835 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Hook > () = spicy::Hook(std::move(yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), std::move(yystack_[1].value.as< spicy::Engine > ()), std::move(yystack_[2].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5493 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 245:
#line 838 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 5499 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 246:
#line 839 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 5505 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 247:
#line 843 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), yystack_[0].value.as< hilti::Attribute > ()); }
#line 5511 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 248:
#line 844 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = {}; }
#line 5517 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 249:
#line 846 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableHookIDMode(); }
#line 5523 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 250:
#line 848 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableHookIDMode(); }
#line 5529 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 251:
#line 848 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(hilti::util::replace(yystack_[1].value.as< std::string > (), "%", "0x25_"), __loc__); }
#line 5535 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 252:
#line 851 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute("foreach", __loc__); }
#line 5541 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 253:
#line 852 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute("priority", std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5547 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 254:
#line 853 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { if ( yystack_[0].value.as< std::string > () != "%debug" ) error(yylhs.location, "unexpected hook property, only %debug permitted");
                                                   yylhs.value.as< hilti::Attribute > () = hilti::Attribute("%debug", __loc__);
                                                 }
#line 5555 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 255:
#line 858 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Composer; }
#line 5561 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 256:
#line 859 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Parser; }
#line 5567 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 257:
#line 860 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Parser; }
#line 5573 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 258:
#line 863 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::Switch(std::move(yystack_[6].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[4].value.as< std::vector<spicy::type::unit::item::switch_::Case> > ()), spicy::Engine::All, std::move(yystack_[1].value.as< std::optional<hilti::Expression> > ()), {}, std::move(yystack_[2].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5579 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 259:
#line 865 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5585 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 260:
#line 866 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 5591 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 261:
#line 870 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > () = std::move(yystack_[1].value.as< std::vector<spicy::type::unit::item::switch_::Case> > ()); yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > ().push_back(std::move(yystack_[0].value.as< spicy::type::unit::item::switch_::Case > ())); }
#line 5597 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 262:
#line 871 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > () = std::vector<spicy::type::unit::item::switch_::Case>(); yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > ().push_back(std::move(yystack_[0].value.as< spicy::type::unit::item::switch_::Case > ())); }
#line 5603 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 263:
#line 874 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[4].value.as< std::vector<hilti::Expression> > (), yystack_[1].value.as< std::vector<spicy::type::unit::Item> > (), __loc__); }
#line 5609 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 264:
#line 875 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[1].value.as< std::vector<spicy::type::unit::Item> > (), __loc__); }
#line 5615 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 265:
#line 876 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[2].value.as< std::vector<hilti::Expression> > (), {yystack_[0].value.as< spicy::type::unit::Item > ()}, __loc__); }
#line 5621 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 266:
#line 877 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(std::vector<type::unit::Item>{yystack_[0].value.as< spicy::type::unit::Item > ()}, __loc__); }
#line 5627 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 267:
#line 878 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[0].value.as< spicy::type::unit::Item > (), __loc__); }
#line 5633 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 268:
#line 885 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableExpressionMode(); }
#line 5639 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 269:
#line 887 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableExpressionMode(); }
#line 5645 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 270:
#line 888 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5651 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 271:
#line 891 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as< std::vector<hilti::Expression> > ()); }
#line 5657 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 272:
#line 892 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<Expression>(); }
#line 5663 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 273:
#line 894 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()); yylhs.value.as< std::vector<hilti::Expression> > ().push_back(std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 5669 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 274:
#line 895 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<Expression>{std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 5675 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 275:
#line 897 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5681 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 276:
#line 900 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Assign(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5687 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 277:
#line 901 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5693 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 278:
#line 902 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5699 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 279:
#line 903 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5705 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 280:
#line 904 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5711 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 281:
#line 905 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ternary(std::move(yystack_[4].value.as< hilti::Expression > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5717 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 282:
#line 906 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5723 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 283:
#line 908 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalOr(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5729 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 284:
#line 909 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5735 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 285:
#line 911 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalAnd(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5741 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 286:
#line 912 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5747 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 287:
#line 914 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5753 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 288:
#line 915 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5759 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 289:
#line 916 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5765 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 290:
#line 918 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5771 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 291:
#line 919 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5777 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 292:
#line 920 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5783 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 293:
#line 921 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5789 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 294:
#line 922 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5795 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 295:
#line 924 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5801 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 296:
#line 925 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5807 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 297:
#line 927 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5813 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 298:
#line 928 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5819 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 299:
#line 930 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5825 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 300:
#line 931 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5831 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 301:
#line 933 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5837 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 302:
#line 934 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5843 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 303:
#line 935 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5849 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 304:
#line 937 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5855 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 305:
#line 938 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5861 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 306:
#line 939 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5867 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 307:
#line 941 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5873 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 308:
#line 942 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5879 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 309:
#line 943 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5885 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 310:
#line 944 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5891 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 311:
#line 945 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5897 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 312:
#line 947 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalNot(std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5903 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 313:
#line 948 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5909 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 314:
#line 949 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5915 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 315:
#line 950 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5921 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 316:
#line 951 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5927 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 317:
#line 952 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5933 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 318:
#line 953 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5939 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 319:
#line 955 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5945 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 320:
#line 956 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5951 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 321:
#line 957 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as< hilti::Expression > ()), std::move(yystack_[3].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5957 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 322:
#line 958 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5963 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 323:
#line 959 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5969 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 324:
#line 960 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5975 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 325:
#line 961 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalNot(hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__)); }
#line 5981 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 326:
#line 962 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5987 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 327:
#line 963 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5993 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 328:
#line 964 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5999 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 329:
#line 965 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 6005 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 330:
#line 967 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as< hilti::Expression > ()), hilti::expression::Type_(std::move(yystack_[4].value.as< hilti::Type > ()))}, __loc__); }
#line 6011 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 331:
#line 968 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Pack, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 6017 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 332:
#line 969 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unpack, {hilti::expression::Type_(std::move(yystack_[2].value.as< hilti::Type > ())), std::move(yystack_[0].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Bool(true), __loc__)}, __loc__); }
#line 6023 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 333:
#line 970 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 6029 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 334:
#line 971 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 6035 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 335:
#line 972 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Ctor(std::move(yystack_[0].value.as< hilti::Ctor > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 6041 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 336:
#line 973 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 6047 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 337:
#line 974 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::UnresolvedID(std::move(yystack_[3].value.as< hilti::ID > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 6053 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 338:
#line 975 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 6059 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 339:
#line 977 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as< hilti::Ctor > ()), __loc__); }
#line 6065 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 340:
#line 978 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 6071 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 341:
#line 979 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 6077 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 342:
#line 981 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[1].value.as< hilti::Expression > ()), std::move(yystack_[5].value.as< hilti::Expression > ()), std::move(yystack_[3].value.as< hilti::ID > ()), {},  __loc__); }
#line 6083 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 343:
#line 983 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[7].value.as< hilti::Expression > ()), std::move(yystack_[5].value.as< hilti::ID > ()), std::move(yystack_[1].value.as< hilti::Expression > ()),  __loc__); }
#line 6089 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 344:
#line 984 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 6095 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 345:
#line 986 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Grouping(std::move(yystack_[1].value.as< hilti::Expression > ())); }
#line 6101 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 346:
#line 987 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 6107 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 347:
#line 988 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedID(std::move("__dd"), __loc__);}
#line 6113 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 348:
#line 989 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { // $N -> $@[N] (with $@ being available internally only, not exposed to users)
                                                   auto captures = hilti::expression::Keyword(hilti::expression::keyword::Kind::Captures, hilti::builder::typeByID("hilti::Captures"), __loc__);
                                                   auto index = hilti::expression::Ctor(hilti::ctor::UnsignedInteger(yystack_[0].value.as< uint64_t > (), 64, __loc__), __loc__);
                                                   yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(captures), std::move(index)}, __loc__);
                                                 }
#line 6123 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 349:
#line 995 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Member(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 6129 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 350:
#line 999 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Address(hilti::ctor::Address::Value(yystack_[0].value.as< std::string > ()), __loc__); }
#line 6135 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 351:
#line 1000 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Network(hilti::ctor::Network::Value(yystack_[2].value.as< std::string > (), yystack_[0].value.as< uint64_t > ()), __loc__); }
#line 6141 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 352:
#line 1001 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Bool(yystack_[0].value.as< bool > (), __loc__); }
#line 6147 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 353:
#line 1002 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Bytes(std::move(yystack_[0].value.as< std::string > ()), __loc__); }
#line 6153 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 354:
#line 1003 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Port(hilti::ctor::Port::Value(yystack_[0].value.as< std::string > ()), __loc__); }
#line 6159 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 355:
#line 1004 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Null(__loc__); }
#line 6165 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 356:
#line 1005 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::String(yystack_[0].value.as< std::string > (), __loc__); }
#line 6171 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 357:
#line 1006 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[0].value.as< uint64_t > (), 64, __loc__); }
#line 6177 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 358:
#line 1007 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { if ( yystack_[0].value.as< uint64_t > () > static_cast<uint64_t>(std::numeric_limits<int64_t>::max()) )
                                                    hilti::logger().error("integer constant out of range", __loc__.location());

                                                   yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[0].value.as< uint64_t > (), 64, __loc__);
                                                 }
#line 6187 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 359:
#line 1012 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as< double > (), __loc__); }
#line 6193 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 360:
#line 1013 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as< double > (), __loc__);; }
#line 6199 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 361:
#line 1018 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Optional(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 6205 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 362:
#line 1019 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6211 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 363:
#line 1020 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6217 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 364:
#line 1021 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6223 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 365:
#line 1022 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6229 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 366:
#line 1023 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6235 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 367:
#line 1024 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6241 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 368:
#line 1025 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6247 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 369:
#line 1028 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("interval", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6253 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 370:
#line 1029 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("interval_ns", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6259 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 371:
#line 1030 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("time", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6265 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 372:
#line 1031 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("time_ns", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6271 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 373:
#line 1032 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("stream", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6277 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 374:
#line 1033 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("int8", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6283 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 375:
#line 1034 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("int16", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6289 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 376:
#line 1035 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("int32", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6295 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 377:
#line 1036 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("int64", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6301 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 378:
#line 1037 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("uint8", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6307 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 379:
#line 1038 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("uint16", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6313 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 380:
#line 1039 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("uint32", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6319 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 381:
#line 1040 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("uint64", { std::move(yystack_[1].value.as< hilti::Expression > ()) }, __loc__); }
#line 6325 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 382:
#line 1041 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::namedCtor("port", {std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 6331 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 383:
#line 1044 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6337 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 384:
#line 1045 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6343 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 385:
#line 1048 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 6349 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 386:
#line 1049 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as< hilti::Expression > ())}; yylhs.value.as< std::vector<hilti::Expression> > ().insert(yylhs.value.as< std::vector<hilti::Expression> > ().end(), yystack_[0].value.as< std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as< std::vector<hilti::Expression> > ().end()); }
#line 6355 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 387:
#line 1050 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 6361 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 388:
#line 1053 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 6367 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 389:
#line 1054 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as< hilti::Expression > ())}; yylhs.value.as< std::vector<hilti::Expression> > ().insert(yylhs.value.as< std::vector<hilti::Expression> > ().end(), yystack_[0].value.as< std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as< std::vector<hilti::Expression> > ().end()); }
#line 6373 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 390:
#line 1055 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 6379 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 391:
#line 1056 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 6385 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 392:
#line 1059 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 6391 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 393:
#line 1060 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ctor(hilti::ctor::Null(__loc__), __loc__); }
#line 6397 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 394:
#line 1062 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as< hilti::Ctor > ()), __loc__); }
#line 6403 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 395:
#line 1064 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6409 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 396:
#line 1065 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6415 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 397:
#line 1067 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6421 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 398:
#line 1069 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6427 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 399:
#line 1071 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6433 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 400:
#line 1073 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6439 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 401:
#line 1075 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6445 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 402:
#line 1077 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[1].value.as< std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 6451 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 403:
#line 1079 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[6].value.as< hilti::Type > ()), std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 6457 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 404:
#line 1081 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Struct(std::move(yystack_[1].value.as< std::vector<hilti::ctor::struct_::Field> > ()), __loc__); }
#line 6463 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 405:
#line 1084 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > () = std::move(yystack_[2].value.as< std::vector<hilti::ctor::struct_::Field> > ()); yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > ().push_back(yystack_[0].value.as< hilti::ctor::struct_::Field > ()); }
#line 6469 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 406:
#line 1085 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > () = std::vector<hilti::ctor::struct_::Field>{ std::move(yystack_[0].value.as< hilti::ctor::struct_::Field > ()) }; }
#line 6475 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 407:
#line 1087 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ctor::struct_::Field > () = hilti::ctor::struct_::Field(hilti::ID(std::move(yystack_[2].value.as< std::string > ())), std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 6481 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 408:
#line 1089 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::RegExp(std::move(yystack_[0].value.as< std::vector<std::string> > ()), {}, __loc__); }
#line 6487 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 409:
#line 1092 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<std::string> > () = yystack_[2].value.as< std::vector<std::string> > (); yylhs.value.as< std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as< std::string > ())); }
#line 6493 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 410:
#line 1093 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as< std::string > ())}; }
#line 6499 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 411:
#line 1096 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enablePatternMode(); }
#line 6505 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 412:
#line 1096 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disablePatternMode(); }
#line 6511 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 413:
#line 1097 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::string > () = std::move(yystack_[2].value.as< std::string > ()); }
#line 6517 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 414:
#line 1099 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[0].value.as< std::vector<hilti::ctor::map::Element> > ()); }
#line 6523 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 415:
#line 1100 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); }
#line 6529 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 416:
#line 1102 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[2].value.as< std::vector<hilti::ctor::map::Element> > ()); yylhs.value.as< std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::ctor::map::Element > ())); }
#line 6535 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 417:
#line 1103 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); yylhs.value.as< std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::ctor::map::Element > ())); }
#line 6541 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 418:
#line 1105 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ctor::map::Element > () = hilti::ctor::map::Element(yystack_[2].value.as< hilti::Expression > (), yystack_[0].value.as< hilti::Expression > ()); }
#line 6547 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 419:
#line 1109 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute(std::move(yystack_[0].value.as< std::string > ()), __loc__); }
#line 6553 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 420:
#line 1110 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute(std::move(yystack_[2].value.as< std::string > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 6559 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 421:
#line 1113 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), yystack_[0].value.as< hilti::Attribute > ()); }
#line 6565 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 422:
#line 1114 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = {}; }
#line 6571 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;


#line 6575 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int Parser::yypact_ninf_ = -675;

  const short int Parser::yytable_ninf_ = -416;

  const short int
  Parser::yypact_[] =
  {
     125,   -48,  -675,    51,    73,  -675,  -675,  -675,  1198,  -675,
    -675,   -55,  -675,  -675,  -675,   -66,  -675,  -675,  -675,  -675,
    -675,  -675,   -10,     8,  -675,     7,    32,   101,   130,   139,
     150,   167,    65,   148,  1198,   621,   211,   -88,  1198,   216,
     160,   285,   291,   297,   303,   312,   338,   341,   349,     8,
     184,   -49,  1198,   188,  1789,     4,  1198,  -675,  1198,  1198,
    -675,  -675,  -675,  -675,   244,   279,    35,   155,   293,   354,
     351,   307,   217,   136,  -675,   204,  -675,  -675,  -675,  -675,
    -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,   358,  -675,
    -675,   156,  -675,  -675,  2076,  -675,  -675,  -675,  -675,  -675,
    -675,  -675,   373,  2076,   378,  2076,  -675,   -49,     4,   383,
    -675,  -675,  -675,  -675,  -675,  -675,   373,  2076,  -675,  -675,
    -675,   373,  -675,  -675,  -675,  -675,  2076,   373,  2076,  -675,
     385,   386,   387,  -675,  -675,  -675,  -675,   390,   483,   380,
     392,   -81,  -675,   379,   531,  -675,  -675,  -675,  1198,  1198,
    1198,  1198,  1198,  1198,  -675,  1198,  1198,  1198,  1198,  1198,
    1198,  1198,  1198,  1198,  1198,  1198,  1198,  1198,  1198,  1198,
    1198,  1198,  1198,    73,  1662,  -675,  1662,  -675,    73,   373,
    -675,    73,   381,  -675,  -675,   395,  -675,  -675,   397,  -675,
    -675,  -675,   396,  -675,  -675,  -675,  -675,  -675,     8,     8,
     400,     8,  -675,     8,  -675,  -675,     8,  -675,  -675,  -675,
     401,  -675,     8,  -675,  -675,  -675,  -675,   403,     8,     8,
    -675,  -675,  -675,  -675,  -675,   196,  -675,  -675,  -675,  -675,
    -675,   406,   407,   411,   413,   414,   416,   417,  -675,   418,
     196,   421,   420,   404,  -675,    -1,  -675,   373,   422,   424,
     427,   196,   428,   429,   430,   431,   433,   437,   440,   443,
     196,   444,   196,  -675,  -675,   -39,  -675,    73,  -675,  -675,
     564,  -675,  -675,  -675,  -675,  -675,   279,  -675,  -675,  -675,
     447,    35,   155,   155,   293,   293,   293,   293,   354,   351,
     307,   217,   217,   136,   136,  -675,  -675,  -675,  -675,  -675,
    -675,   391,   405,  -675,   450,   442,   455,  -675,  1968,  -675,
     588,    73,  2076,  2076,   595,  2076,  2076,  2076,  -675,  1863,
      24,   456,  2076,  2076,   172,  -675,   458,  -675,  -675,  -675,
    -675,  -675,  -675,  -675,  -675,   460,  -675,  -675,  -675,  2076,
     462,  -675,  -675,  -675,   461,  -675,  -675,  -675,  -675,  -675,
    -675,  -675,  -675,   -88,  -675,   464,  -675,   357,  -675,   548,
    -675,  -675,   451,  -675,  -675,  -675,   373,   364,  -675,  -675,
    -675,   470,   474,  -675,   472,   473,    73,   509,  -675,   477,
    -675,  -675,   480,   482,   485,   493,   497,  -675,  -675,   495,
    -675,   879,  1040,  -675,  -675,  -675,  -675,  -675,  -675,   313,
    -675,  -675,   499,  -675,   479,   484,   236,  -675,   196,   196,
     496,   274,   196,   196,    11,   491,   500,   498,   -14,  -675,
    -675,   501,   502,  -675,    73,    16,   196,   196,  -675,   -49,
    -675,  -675,   196,  -675,   504,   -49,  -675,   -49,   -39,  -675,
    -675,  -675,   505,  -675,  2300,   265,   314,   503,  -675,  -675,
     511,    73,   569,   -42,   367,   512,   654,   517,  -675,   518,
    -675,   569,  -675,  -675,   519,   522,   569,   509,  -675,   509,
     509,  -675,  -675,   653,    73,  -675,  -675,  -675,  -675,  2076,
    -675,  -675,  -675,   525,  -675,  -675,  2076,  2076,  -675,  -675,
     606,   527,   532,  -675,    73,   535,    73,  -675,    19,   528,
    -675,  -675,  -675,  -675,  -675,  -675,   193,  -675,  -675,  -675,
     530,   536,   539,  -675,   540,   542,  -675,   -35,  -675,   543,
     549,  -675,  -675,  -675,  -675,  -675,  -675,   618,    73,   264,
     544,  -675,  -675,  -675,  2076,    24,  -675,  -675,  -675,  -675,
    -675,   547,   550,  -675,  -675,   266,   556,   560,   699,   563,
     565,   561,  -675,  -675,   196,  2076,   498,  -675,  -675,  2076,
    2374,    39,   512,  -675,  -675,   567,   568,  -675,  -675,  -675,
    -675,  -675,  -675,  -675,  -675,   378,  -675,  -675,  -675,  -675,
    -675,  -675,   571,   574,  -675,   369,  -675,  2200,  2200,   576,
     710,   580,   -82,   577,   360,  -675,   578,   581,  -675,  2200,
    2200,   582,   584,  -675,   509,   591,   587,  -675,    73,  -675,
     498,   -44,   593,  -675,   594,  -675,  -675,  -675,    48,   597,
      -6,  2076,  1509,   614,   599,   583,  -675,  -675,   601,  -675,
    2076,   602,   702,  -675,  -675,     1,   694,  -675,  -675,   706,
    -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,
     609,  -675,   605,     2,     2,   610,  -675,  -675,  -675,  2076,
     616,  -675,  2076,  2076,   615,   613,    73,  -675,    54,  -675,
    -675,  -675,    55,  -675,  -675,  -675,   765,   744,    -9,  -675,
      44,   -44,   624,   625,   626,   627,   148,   247,   160,   248,
     628,   631,   635,   636,   184,  1356,   637,   629,   629,  -675,
    -675,  -675,  -675,  -675,  2200,  -675,    93,  2200,   639,  2139,
    -675,  2200,  -675,  -675,  -675,   644,  -675,  -675,  -675,   649,
      90,  -675,   106,  2200,   652,   128,    24,   655,  -675,   166,
     498,   782,  -675,  -675,  -675,  -675,  -675,  -675,  -675,    79,
    -675,  -675,    80,  -675,    31,    31,    31,    31,  2076,  2076,
      12,    12,    12,    12,  2076,   651,   629,   657,   651,   373,
     629,   641,  -675,  -675,  -675,  -675,  -675,   754,  -675,  -675,
    -675,  -675,  -675,   187,  2200,  -675,  -675,  -675,  -675,  -675,
    -675,   660,  -675,  -675,  -675,    60,   757,   218,  -675,    69,
     282,  -675,    61,  -675,   788,   795,   663,   664,   665,   666,
     278,   196,  -675,   801,   670,   675,   676,   678,   196,   629,
     651,   629,  -675,   679,  -675,  -675,   669,    69,    69,  -675,
    -675,  2200,  -675,   685,   686,   687,  -675,   819,    66,    49,
     688,   693,    64,  -675,  -675,  -675,  -675,  -675,  -675,  -675,
    2076,   692,  -675,  -675,  -675,  -675,  -675,   695,  -675,  -675,
    -675,   834,  -675,    69,  -675,   816,   816,  -675,  -675,  2076,
    -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,   196,
     834,   834,    69,   816,  -675,   292,   292,   498,     9,    67,
     696,   698,   816,   292,   392,  -675,  -675,    22,  -675,  -675,
     703,   605,  -675,  -675,   292,  -675,  -675,  -675,  -675,  -675
  };

  const unsigned short int
  Parser::yydefact_[] =
  {
       0,     0,   268,     0,     0,     2,     3,     4,     0,     1,
       7,     0,     9,   356,   353,   350,   354,   359,   357,   348,
     352,   355,     0,     0,   347,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   268,     0,     0,     0,   268,     0,   411,     0,     0,
       8,   346,   269,   275,   282,   284,   286,   289,   294,   296,
     298,   300,   303,   306,   311,   318,   329,   338,   344,   339,
     340,   367,   362,   368,   365,   363,   366,   364,   408,   410,
       5,     0,   268,   153,     0,   268,   268,   268,   268,   268,
     268,   268,   268,     0,   268,     0,   316,   268,   268,   336,
     335,   268,   394,   331,   317,   268,   268,     0,   268,   268,
     268,   268,   268,   268,   268,   268,     0,   268,     0,   393,
     392,     0,   385,   313,   360,   358,   341,     0,   274,     0,
     271,     0,   406,     0,     0,   312,   314,   270,     0,     0,
       0,     0,     0,     0,   268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   326,     0,   327,     0,   268,
     268,     0,     0,    15,   351,     0,   113,   112,     0,   114,
     115,   119,     0,   126,   127,   128,   125,   116,     0,     0,
       0,     0,   117,     0,   118,   120,     0,   140,   121,   122,
       0,   123,     0,   130,   131,   132,   129,   182,     0,     0,
     124,   152,   148,   151,   150,     0,   142,   143,   144,   145,
     146,     0,     0,     0,     0,     0,     0,     0,   274,     0,
       0,     0,     0,   414,   417,     0,   392,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   345,   383,   268,   268,     0,   395,   268,
       0,   404,   315,   412,   280,   277,   283,   278,   279,   276,
       0,   285,   287,   288,   292,   293,   290,   291,   295,   297,
     299,   301,   302,   304,   305,   310,   308,   307,   309,   349,
     323,   324,   325,   328,     0,     0,   320,   409,   268,   333,
       0,     0,     0,     0,     0,     0,     0,     0,   164,     0,
      57,     0,     0,     0,   147,   154,     0,   334,   375,   376,
     377,   374,   369,   370,   396,     0,   268,   402,   268,     0,
       0,   361,   268,   400,     0,   373,   371,   372,   384,   379,
     380,   381,   378,     0,   398,     0,   386,   388,   407,     0,
     273,   405,     0,   268,   319,   322,   268,     0,   268,   268,
     268,     0,     0,   268,     0,     0,     0,     0,   249,   268,
      51,    50,   268,     0,     0,     0,     0,   268,   268,     0,
      13,    16,    17,   108,    18,    19,    20,    21,    22,     0,
      14,    76,     0,   111,     0,   170,     0,   169,     0,     0,
       0,     0,     0,     0,     0,     0,     8,   160,     0,   159,
      64,     0,    56,    59,     0,   221,     0,     0,   268,   268,
     418,   416,     0,   337,     0,   268,   332,   268,   268,   268,
     413,   281,     0,    46,   268,     0,     0,     0,    81,    82,
       0,     0,   268,     0,     0,   246,     0,     0,    88,     0,
      90,   268,    94,    95,     0,     0,   268,     0,    53,     0,
       0,    75,   172,     0,   168,   166,   134,   133,   141,     0,
     135,   138,   162,     0,   163,   155,     0,   158,   156,   181,
      65,     0,   422,   249,     0,   260,     0,   220,   221,     0,
     184,   188,   191,   190,   187,   189,   225,   192,   139,   136,
       0,     0,     0,   382,     0,     0,   389,     0,   321,     0,
       0,    77,   268,    79,   268,    99,   100,     0,     0,     0,
       0,    10,    44,   268,     0,    57,    49,   248,   250,    87,
      89,     0,     0,    91,   101,     0,     0,    25,    55,    34,
       0,     0,   171,   167,     0,     0,   161,   157,    58,     0,
     268,     0,   246,   422,   268,     0,     0,   183,   180,   222,
     223,   224,   226,   330,   397,   268,   401,   399,   268,   342,
      48,    47,     0,     0,   268,     0,   268,   268,   268,     0,
       0,     0,     0,     0,   257,   251,     0,     0,   268,   268,
     268,     0,     0,    54,     0,     0,     0,    23,   175,   137,
     422,    67,     0,   422,   419,   195,   421,   219,     0,     0,
     268,     0,     0,   229,     0,     0,    78,    80,     0,   268,
       0,     0,   268,   109,   110,     0,   103,    68,    69,   103,
      45,    11,    29,    30,   268,   245,   254,   252,   255,   256,
       0,   247,     0,     0,     0,     0,    98,    97,   268,     0,
       0,   268,     0,     0,     0,     0,   174,   177,     0,   268,
      60,   197,     0,   268,   194,   259,   221,     0,   268,   262,
       0,    67,   126,   127,   128,   125,     0,     0,     0,     0,
     130,   131,   132,   129,     0,   268,   231,   235,   235,   207,
     228,   227,   403,   343,   268,    33,     0,   268,     0,   268,
      74,   268,    85,    84,    12,     0,   268,   244,   268,     0,
       0,   105,     0,   268,     0,     0,    57,     0,    37,     0,
     422,     0,   173,   176,   165,    66,   196,   420,   267,   221,
     422,   261,   221,   422,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   231,   235,     0,   231,   268,
     235,   268,   234,   422,   422,    83,   268,   103,    70,    73,
     102,    31,   253,     0,   268,    93,   104,    92,    96,    26,
     268,     0,    35,    38,   268,     0,   422,   221,   266,   237,
     221,   265,     0,   202,     0,     0,     0,     0,     0,     0,
       0,     0,   205,     0,     0,     0,     0,     0,     0,   235,
     231,   235,   422,     0,   422,   233,     0,   237,   237,    32,
      86,   268,   107,     0,    63,     0,    24,     0,     0,   221,
       0,     0,   221,   193,   203,   204,   213,   214,   215,   212,
       0,   138,   206,   209,   210,   211,   208,   139,   422,   422,
     422,   216,   230,   237,   232,   239,   239,   106,    28,     0,
      62,   422,    39,   422,   179,   264,   268,   258,   263,     0,
     217,   218,   237,   239,   268,   246,   246,    61,    40,     0,
       0,   137,   239,   246,   238,   241,   198,   240,   243,   199,
       0,     0,   178,   236,   246,   200,   242,    41,    43,   201
  };

  const short int
  Parser::yypgoto_[] =
  {
    -675,  -675,  -675,  -675,  -675,     6,   132,  -675,  -675,  -675,
    -675,  -675,   545,  -675,   546,  -675,  -675,  -675,  -270,  -675,
    -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,   551,
    -675,  -675,  -529,  -675,   366,  -675,  -675,  -675,   169,  -564,
    -643,  -675,  -675,  -305,  -601,   194,  -219,  -675,  -675,   298,
    -675,  -440,   -71,    10,  -132,  -675,  -675,   365,  -675,  -675,
    -675,  -675,  -675,   377,  -675,  -675,  -675,  -675,   191,  -675,
    -675,  -321,  -675,  -486,  -675,  -675,  -675,   185,  -522,  -353,
    -675,  -675,  -675,  -675,  -675,  -675,  -675,  -675,  -674,  -675,
    -464,  -463,  -494,  -622,  -675,  -448,  -675,  -675,   370,  -675,
    -675,  -675,  -675,  -675,  -675,  -675,   182,    -2,  -675,  -675,
    -101,  -612,  -675,   330,  -675,   712,   711,   368,   315,   705,
     707,   701,   361,   362,   325,   294,  -675,   814,  -675,   308,
     -33,  -675,   -32,  -199,   434,  -252,   516,  -675,  -675,  -675,
    -675,  -675,  -675,   603,  -675,  -675,   689,  -675,  -675,   299,
    -675,   537,  -675,  -456
  };

  const short int
  Parser::yydefgoto_[] =
  {
      -1,     3,     6,     5,   183,    60,    61,   589,   590,   714,
     308,   390,   633,   663,   634,   601,   602,   393,   529,   394,
     605,   606,   728,   395,   890,   891,   396,   397,   398,   635,
     548,   604,   421,   422,   423,   860,   861,   424,   670,   636,
     637,   708,   709,   638,   712,   720,   721,   401,   402,   222,
     223,   224,   417,   316,   326,   226,   418,   419,   227,   414,
     484,   228,   406,   407,   229,   551,   665,   666,   667,   230,
     321,   498,   499,   500,   501,   502,   503,   504,   796,   804,
     698,   757,   505,   506,   572,   622,   623,   701,   760,   762,
     763,   831,   875,   886,   887,   888,   537,   594,   455,   456,
     595,   651,   652,   507,   565,   678,   679,   238,     8,   147,
     139,   140,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,   300,
      79,    80,    81,   131,   356,   132,   113,    82,    83,    84,
      85,    86,   141,   142,    87,    88,    89,   144,   362,   242,
     243,   244,   616,   561
  };

  const short int
  Parser::yytable_[] =
  {
       7,   239,   110,   400,   519,   112,   593,   536,   680,   717,
      11,   137,   567,   357,    10,   250,   531,   614,   676,    10,
     255,   676,    10,   225,   639,   492,   261,   -65,   492,   802,
     578,  -240,   240,    94,   245,   656,   657,   718,   713,   467,
       4,    44,   103,   105,   129,   719,   251,   614,   793,   130,
     117,     9,    10,   138,   129,   260,   614,   262,   492,   126,
     128,   107,   614,   614,   643,   644,   680,    10,   614,   614,
     270,   742,   324,   492,   614,   614,    10,   614,   304,  -246,
     271,   809,    10,    10,   812,  -246,  -246,   156,   492,   492,
     185,    90,   420,   231,   232,   233,   234,   235,   236,   237,
      91,  -387,   241,   669,   532,   246,   773,   618,   335,   248,
     324,  -391,   493,   249,   617,   493,   252,   253,   254,   344,
     256,   257,   258,   259,   157,   718,   579,  -246,   353,   494,
     355,   470,   494,   719,   830,   495,   849,   487,   495,    92,
     765,   718,   325,   767,   740,   493,   340,   770,   677,   719,
     339,   677,   280,   324,   668,   496,    95,   672,   496,   778,
     493,   -42,   494,    93,   482,  -272,   820,   109,   495,  -186,
     803,   535,  -185,   184,  -246,   493,   493,   494,   305,   299,
    -147,    96,   697,   495,   299,   615,   357,   299,   496,   794,
     795,   541,   494,   494,   674,   269,   545,   781,   495,   495,
     734,   736,   865,   496,   134,   135,   826,   833,   312,   313,
     822,   315,   864,   892,   102,   158,   317,   868,   496,   496,
      93,    10,   319,   797,   798,   799,   221,   492,   322,   323,
     511,   787,   790,   159,   764,   221,   514,   221,   515,   169,
     766,   408,   409,   775,   411,   412,   413,   324,   898,   221,
      97,   426,   427,   788,   889,   756,   791,   857,   221,   777,
     221,   895,   884,   246,   358,   442,   173,   360,   432,     1,
       2,   174,   899,   359,   785,   780,   476,   477,   457,    98,
     480,   481,   324,   485,   789,    10,   488,   792,    99,   148,
     175,   492,   810,   170,   508,   509,   814,   104,   176,   100,
     512,   171,   172,    93,   155,   177,   403,   817,   818,   116,
     160,   161,   783,   784,   493,    93,   101,   405,  -147,  -147,
     324,   112,  -147,  -147,  -147,   416,  -147,   710,  -147,   149,
     828,   494,   178,   127,   430,   821,   241,   495,   269,    93,
     434,   569,   150,   567,   151,   848,   567,   850,   570,   571,
     324,   467,   325,   179,   855,   856,   851,   496,   853,   106,
     111,   441,   876,   114,   180,   115,   445,   446,   447,   646,
     152,   450,   468,   181,   469,   167,   168,   133,   493,   883,
     459,   143,   453,   145,   146,   464,   465,   474,   894,   475,
     873,   153,   870,   871,   872,   494,   111,   121,   805,   806,
     807,   495,    93,    93,   769,   878,   154,   879,   554,   882,
     586,   521,   598,   522,   587,   556,   599,   647,   165,   166,
     483,   496,   609,   648,   649,   479,   510,   246,   324,   840,
     491,   497,   324,   246,   118,   246,   246,   517,   885,   896,
     119,   535,   520,   470,   221,   221,   120,   221,   221,   221,
     530,   221,   121,   173,   221,   221,   162,   527,   174,   542,
     523,   122,   524,   592,   546,   650,   829,   173,   301,   832,
     302,   221,   174,   284,   285,   286,   287,   175,   274,   275,
     405,   277,   278,   279,   610,   176,   303,   123,   611,   306,
     124,   175,   177,   416,   295,   296,   297,   298,   125,   176,
     563,   776,   566,   776,   497,   164,   177,  -388,   438,   454,
     443,   444,    10,    12,   533,   534,   629,   630,   163,   178,
     582,   182,   583,  -272,   282,   283,   291,   292,  -415,   293,
     294,   591,   247,   178,   585,   263,   264,   266,   265,   267,
     179,   268,   272,   269,   273,   309,   310,    57,   311,   314,
     681,   180,   320,   318,   179,   338,   327,   328,   613,   706,
     181,   329,   619,   330,   331,   180,   332,   333,   334,   336,
     337,   137,   341,   241,   181,   342,   625,   343,   345,   346,
     347,   348,   628,   349,   631,   403,   403,   350,   725,   699,
     351,   729,   730,   352,   354,   363,   655,   403,   403,   547,
     364,   549,   550,   365,   366,   404,   410,   428,   425,   429,
     435,   221,   433,   437,   664,   439,   448,   440,   221,   221,
     449,   451,   452,  -272,    10,    12,   458,   705,   460,   472,
     403,   473,    13,    14,   461,    15,    16,    17,    18,   462,
      20,    21,   715,   463,   466,   471,   478,   325,   486,   525,
     528,   489,   324,   490,   513,   518,   724,   526,   813,   727,
     538,   535,   758,   539,   540,   543,   221,   735,   544,   841,
     552,   737,   664,   555,   420,   559,   847,   800,   801,   560,
     573,   568,   497,   808,   564,   584,   574,   221,   575,   580,
     576,   221,   577,   246,   588,   581,   748,   596,   749,   319,
     597,    32,   403,    33,   754,   403,   600,   403,   -27,   403,
     603,   -36,   607,   608,   772,   641,   621,   626,    36,   620,
     627,   403,   640,   368,   369,   370,   642,   645,   700,   658,
     653,    40,   659,   654,   371,   662,   660,   881,   661,   671,
     -52,   673,   372,   711,   703,   497,   373,   675,   497,   702,
      44,   704,   707,   221,   696,   711,   716,   632,   374,   816,
     723,    50,   221,   731,   819,   726,   732,   375,    10,   869,
     107,   739,   403,   744,   745,   746,   747,   750,   823,    53,
     751,   108,   825,   377,   752,   753,   759,    57,   877,   761,
     771,   221,   768,   497,   221,   221,   497,   774,   779,   786,
     759,   782,   815,   711,   827,   834,   379,   811,   380,   381,
     824,   382,   835,   836,   837,   838,   839,   383,   842,   403,
     843,   384,   385,   386,   387,   844,   845,   755,   846,   852,
     854,   858,   -52,   862,   859,   497,   863,   866,   497,   867,
     388,   435,   614,   874,   437,   389,   893,   575,   722,   897,
     743,   553,   557,   391,   392,   -72,   558,   733,   612,   399,
     741,   738,   276,   562,   880,   290,   281,   288,   136,   436,
     289,   307,   516,   361,   624,   431,     0,     0,     0,   -16,
     221,   221,   -16,   -16,     0,     0,   221,     0,   -16,     0,
     -16,   -16,     0,   -16,   -16,   -16,   -16,   -16,   -16,   -16,
     -16,   -16,   -16,     0,     0,     0,     0,     0,     0,   -16,
       0,   -16,     0,     0,     0,   -16,     0,   -16,     0,   -16,
       0,     0,     0,   -16,     0,   -16,     0,     0,     0,   -16,
       0,     0,     0,     0,     0,   -16,     0,     0,   -16,     0,
     -16,     0,     0,     0,   -16,   -16,     0,     0,     0,   -16,
     -16,   -16,   -16,   -16,   -16,     0,     0,     0,     0,   -16,
     -16,   -16,     0,     0,     0,   -16,     0,     0,     0,     0,
       0,   -16,   221,     0,     0,   -16,   -16,     0,   -16,     0,
     -16,   -16,     0,   -16,     0,   -16,   -16,     0,   -16,   -16,
       0,   221,     0,     0,   -16,   -16,     0,     0,   -16,   -16,
     -16,   -16,   -16,   -16,     0,     0,     0,     0,   -16,   -16,
       0,   -16,   -16,   -16,   -16,     0,   -16,   -16,     0,   -16,
       0,     0,   -16,     0,     0,     0,     0,     0,   -16,     0,
       0,     0,     0,     0,     0,     0,   -16,   -16,   -16,   -16,
     -17,     0,   -16,   -17,   -17,   -16,   -16,   -16,     0,   -17,
       0,   -17,   -17,     0,   -17,   -17,   -17,   -17,   -17,   -17,
     -17,   -17,   -17,   -17,     0,     0,     0,     0,     0,     0,
     -17,     0,   -17,     0,     0,     0,   -17,     0,   -17,     0,
     -17,     0,     0,     0,   -17,     0,   -17,     0,     0,     0,
     -17,     0,     0,     0,     0,     0,   -17,     0,     0,   -17,
       0,   -17,     0,     0,     0,   -17,   -17,     0,     0,     0,
     -17,   -17,   -17,   -17,   -17,   -17,     0,     0,     0,     0,
     -17,   -17,   -17,     0,     0,     0,   -17,     0,     0,     0,
       0,     0,   -17,     0,     0,     0,   -17,   -17,     0,   -17,
       0,   -17,   -17,     0,   -17,     0,   -17,   -17,     0,   -17,
     -17,     0,     0,     0,     0,   -17,   -17,     0,     0,   -17,
     -17,   -17,   -17,   -17,   -17,     0,     0,     0,     0,   -17,
     -17,     0,   -17,   -17,   -17,   -17,     0,   -17,   -17,     0,
     -17,     0,     0,   -17,     0,     0,     0,     0,     0,   -17,
       0,     0,     0,     0,     0,     0,     0,   -17,   -17,   -17,
     -17,    10,    12,   -17,     0,     0,   -17,   -17,   -17,    13,
      14,     0,    15,    16,    17,    18,    19,    20,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,    23,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    24,     0,     0,     0,    25,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    26,    27,
      28,    29,    30,    31,     0,     0,     0,     0,    32,     0,
      33,     0,     0,     0,    34,     0,     0,     0,     0,     0,
      35,     0,     0,     0,     0,    36,     0,    37,     0,    38,
      39,     0,     0,     0,     0,     0,     0,     0,    40,     0,
       0,     0,     0,     0,    41,     0,     0,     0,     0,     0,
       0,    42,    43,     0,     0,     0,     0,    44,     0,     0,
      45,    46,    47,    48,     0,    49,     0,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,    51,     0,     0,
       0,     0,     0,     0,     0,    52,    53,    54,    55,    10,
      12,    56,     0,     0,    57,    58,    59,    13,    14,     0,
      15,    16,    17,    18,     0,    20,    21,     0,     0,     0,
     186,     0,   187,     0,     0,   188,     0,   189,     0,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,     0,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   194,   195,   196,
     197,     0,   198,   199,     0,   200,    32,     0,   686,     0,
       0,     0,     0,     0,     0,     0,     0,   202,     0,   129,
       0,     0,     0,   687,     0,     0,     0,     0,   204,     0,
       0,     0,     0,     0,   205,     0,   688,     0,     0,   207,
       0,     0,   208,   209,   210,     0,     0,     0,     0,   211,
       0,     0,     0,     0,     0,   689,     0,     0,   213,   214,
     215,   216,   217,     0,     0,     0,   694,   219,   220,     0,
       0,     0,     0,     0,     0,   107,  -387,     0,     0,     0,
       0,     0,    10,    12,    53,     0,   108,     0,     0,     0,
      13,    14,    57,    15,    16,    17,    18,     0,    20,    21,
       0,     0,     0,   186,     0,   187,     0,     0,   188,     0,
     189,     0,   190,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   191,     0,     0,
     192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   682,
     683,   684,   685,   197,     0,   198,   199,     0,   200,    32,
       0,   686,     0,     0,     0,     0,     0,     0,     0,     0,
     202,     0,     0,     0,     0,     0,   687,     0,     0,     0,
       0,   204,     0,     0,     0,     0,     0,   205,     0,   688,
       0,     0,   207,     0,     0,   208,   209,   210,     0,     0,
       0,     0,   211,     0,     0,     0,     0,     0,   689,     0,
       0,   690,   691,   692,   693,   217,     0,     0,     0,   694,
     219,   220,     0,     0,     0,     0,     0,     0,   695,     0,
       0,     0,     0,     0,     0,    10,    12,    53,     0,   108,
       0,     0,     0,    13,    14,    57,    15,    16,    17,    18,
      19,    20,    21,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,     0,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,     0,
       0,     0,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,    27,    28,    29,    30,    31,     0,     0,
       0,     0,    32,     0,    33,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,     0,     0,     0,     0,    36,
       0,    37,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,    40,     0,     0,     0,     0,     0,    41,     0,
       0,     0,     0,     0,     0,    42,    43,     0,     0,     0,
       0,    44,    10,    12,    45,    46,    47,    48,     0,    49,
      13,    14,    50,    15,    16,    17,    18,    19,    20,    21,
       0,    51,     0,     0,     0,     0,     0,     0,     0,     0,
      53,    54,    55,     0,     0,     0,     0,     0,    57,     0,
       0,     0,     0,     0,     0,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    26,
      27,    28,    29,    30,    31,     0,    10,    12,     0,    32,
       0,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,   186,     0,   187,
       0,    39,   188,     0,   189,     0,   190,     0,     0,    40,
       0,     0,     0,     0,     0,    41,     0,     0,     0,     0,
       0,   191,    42,    43,   192,     0,     0,     0,    44,     0,
       0,    45,    46,    47,    48,     0,     0,     0,     0,    50,
       0,     0,     0,   193,   194,   195,   196,   197,    51,   198,
     199,     0,   200,     0,     0,   201,     0,    53,    54,    55,
       0,     0,     0,     0,   202,    57,     0,     0,     0,     0,
     203,     0,     0,     0,     0,   204,     0,     0,    -6,     0,
       0,   205,     0,   206,     0,     0,   207,   367,     0,   208,
     209,   210,     0,     0,     0,     0,   211,     0,     0,   368,
     369,   370,   212,     0,     0,   213,   214,   215,   216,   217,
     371,     0,     0,   218,   219,   220,   -52,     0,   372,     0,
       0,     0,   373,     0,     0,     0,     0,     0,     0,     0,
     415,     0,     0,     0,   374,     0,     0,   -52,     0,   -52,
       0,     0,     0,   375,   376,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   377,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   378,     0,     0,     0,     0,     0,
       0,     0,   379,     0,   380,   381,     0,   382,     0,    10,
      12,     0,     0,   383,     0,     0,     0,   384,   385,   386,
     387,     0,     0,     0,     0,     0,     0,     0,   -52,     0,
     186,     0,   187,     0,     0,   188,   388,   189,     0,   190,
       0,   389,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,     0,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   194,   195,   196,
     197,     0,   198,   199,     0,   200,     0,     0,   201,     0,
     368,   369,   370,     0,     0,     0,     0,   202,     0,     0,
       0,   371,     0,   203,     0,     0,     0,   -52,   204,   372,
       0,     0,     0,   373,   205,     0,   206,     0,     0,   207,
       0,     0,   208,   209,   210,   374,     0,     0,     0,   211,
       0,     0,     0,     0,   375,   212,     0,     0,   213,   214,
     215,   216,   217,     0,     0,     0,   218,   219,   220,     0,
     377,   368,   369,   370,     0,     0,     0,     0,     0,     0,
       0,     0,   371,     0,     0,     0,     0,     0,   -52,     0,
     372,     0,     0,   379,   373,   380,   381,     0,   382,     0,
       0,     0,     0,     0,   383,     0,   374,     0,   384,   385,
     386,   387,     0,     0,     0,   375,     0,     0,     0,   -52,
       0,     0,     0,     0,     0,     0,     0,   388,     0,     0,
       0,   377,   389,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   -71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   379,     0,   380,   381,     0,   382,
       0,     0,     0,     0,     0,   383,     0,     0,     0,   384,
     385,   386,   387,     0,   186,     0,   187,     0,     0,   188,
     -52,   189,     0,   190,     0,     0,     0,     0,   388,     0,
       0,     0,     0,   389,     0,     0,     0,     0,   191,     0,
       0,   192,   632,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   194,   195,   196,   197,     0,   198,   199,     0,   200,
       0,     0,   201,     0,     0,     0,     0,     0,     0,     0,
       0,   202,     0,     0,     0,     0,     0,   203,   186,     0,
     187,     0,   204,   188,     0,   189,     0,   190,   205,     0,
     206,     0,     0,   207,     0,     0,   208,   209,   210,     0,
       0,     0,   191,   211,     0,   192,     0,     0,     0,   212,
       0,     0,   213,   214,   215,   216,   217,     0,     0,     0,
     218,   219,   220,     0,   193,   194,   195,   196,   197,     0,
     198,   199,     0,   200,     0,     0,   201,     0,     0,     0,
       0,     0,     0,     0,     0,   202,     0,     0,     0,     0,
       0,   203,     0,     0,     0,     0,   204,     0,     0,     0,
       0,     0,   205,     0,   206,     0,     0,   207,     0,     0,
     208,   209,   210,     0,     0,     0,     0,   211,     0,     0,
       0,     0,     0,   212,     0,     0,   213,   214,   215,   216,
     217,     0,     0,     0,   218,   219,   220
  };

  const short int
  Parser::yycheck_[] =
  {
       2,   102,    35,   308,   444,    37,   535,   455,   620,   652,
       4,     7,   498,   265,     3,   116,    58,     8,    27,     3,
     121,    27,     3,    94,   588,     9,   127,     3,     9,    17,
      65,     9,   103,    23,   105,   599,   600,    35,   639,    38,
      88,   129,    32,    33,    93,    43,   117,     8,    17,    51,
      40,     0,     3,    55,    93,   126,     8,   128,     9,    49,
      50,   149,     8,     8,   146,   147,   678,     3,     8,     8,
     151,    27,   154,     9,     8,     8,     3,     8,   179,    57,
     161,   755,     3,     3,   758,    63,    64,    52,     9,     9,
      92,   146,    68,    95,    96,    97,    98,    99,   100,   101,
     166,   150,   104,   147,   146,   107,   718,   563,   240,   111,
     154,   150,    96,   115,   562,    96,   118,   119,   120,   251,
     122,   123,   124,   125,    89,    35,   161,   105,   260,   113,
     262,   130,   113,    43,    65,   119,   810,   151,   119,   149,
     704,    35,   156,   707,   153,    96,   247,   711,   157,    43,
     151,   157,   154,   154,   610,   139,   149,   613,   139,   723,
      96,   152,   113,   155,   153,   161,   767,    35,   119,   153,
     158,   149,   153,    17,   152,    96,    96,   113,   180,   173,
       8,   149,   622,   119,   178,   146,   438,   181,   139,   158,
     159,   461,   113,   113,   146,   151,   466,   726,   119,   119,
     146,   146,   153,   139,    16,    17,   146,   146,   198,   199,
     774,   201,   146,   146,   149,    60,   206,   153,   139,   139,
     155,     3,   212,   745,   746,   747,    94,     9,   218,   219,
     429,   152,   152,    78,   698,   103,   435,   105,   437,   103,
     147,   312,   313,   153,   315,   316,   317,   154,   891,   117,
     149,   322,   323,   739,   876,   695,   742,   821,   126,   153,
     128,   883,   874,   265,   266,   366,    62,   269,   339,   144,
     145,    67,   894,   267,   730,   147,   408,   409,   379,   149,
     412,   413,   154,   415,   740,     3,   418,   743,   149,    45,
      86,     9,   756,   157,   426,   427,   760,   149,    94,   149,
     432,   165,   166,   155,    25,   101,   308,   763,   764,   149,
     155,   156,   146,   147,    96,   155,   149,   311,   146,   147,
     154,   353,   150,   151,   152,   319,   154,   632,   156,    85,
     786,   113,   128,   149,   336,   148,   338,   119,   151,   155,
     342,   148,    98,   829,   100,   809,   832,   811,   155,   156,
     154,    38,   156,   149,   817,   818,   812,   139,   814,    34,
     149,   363,   856,    38,   160,   149,   368,   369,   370,     9,
     126,   373,    59,   169,    61,   158,   159,    52,    96,   873,
     382,    56,   376,    58,    59,   387,   388,   151,   882,   153,
     853,   147,   848,   849,   850,   113,   149,   149,   751,   752,
     753,   119,   155,   155,   709,   861,   162,   863,   479,   872,
     146,   146,   146,   148,   150,   486,   150,    57,   111,   112,
     414,   139,   554,    63,    64,   151,   428,   429,   154,   151,
     424,   425,   154,   435,   149,   437,   438,   439,   146,   887,
     149,   149,   444,   130,   312,   313,   149,   315,   316,   317,
     452,   319,   149,    62,   322,   323,   163,   451,    67,   461,
     146,   149,   148,   534,   466,   105,   787,    62,   174,   790,
     176,   339,    67,   158,   159,   160,   161,    86,   148,   149,
     474,   151,   152,   153,   555,    94,   178,   149,   559,   181,
     149,    86,   101,   487,   169,   170,   171,   172,   149,    94,
     494,   720,   496,   722,   498,   154,   101,   150,   151,   377,
     146,   147,     3,     4,   147,   148,   147,   148,   164,   128,
     522,   163,   524,   150,   156,   157,   165,   166,   150,   167,
     168,   533,   149,   128,   528,   150,   150,   147,   151,    56,
     149,   161,   163,   151,    13,   150,   149,   166,   152,   149,
     621,   160,   149,   152,   149,   151,   150,   150,   560,   630,
     169,   150,   564,   150,   150,   160,   150,   150,   150,   148,
     150,     7,   150,   575,   169,   151,   578,   150,   150,   150,
     150,   150,   584,   150,   586,   587,   588,   150,   659,   622,
     150,   662,   663,   150,   150,   148,   598,   599,   600,   467,
     150,   469,   470,   161,   149,    17,    11,   149,   152,   149,
     149,   479,   150,   149,   608,    67,   146,   166,   486,   487,
     146,   149,   149,   146,     3,     4,   146,   629,   146,   150,
     632,   147,    11,    12,   149,    14,    15,    16,    17,   146,
      19,    20,   644,   146,   149,   146,   150,   156,   148,   146,
      81,   150,   154,   151,   150,   150,   658,   146,   759,   661,
       6,   149,   695,   146,   146,   146,   534,   669,   146,   801,
      17,   673,   666,   148,    68,   148,   808,   748,   749,   147,
     150,   153,   676,   754,   149,    67,   150,   555,   149,   146,
     150,   559,   150,   695,   150,   146,   686,   150,   688,   689,
     150,    80,   704,    82,   694,   707,   150,   709,   148,   711,
      11,   148,   147,   152,   716,     5,   148,   146,    97,   152,
     146,   723,   146,    21,    22,    23,   146,   150,   114,   147,
     152,   110,   148,   152,    32,   148,   604,   869,   147,   146,
      38,   147,    40,    49,   161,   739,    44,   150,   742,   150,
     129,   150,   150,   621,   622,    49,   147,   152,    56,   761,
     150,   140,   630,   148,   766,   149,   153,    65,     3,   840,
     149,    27,   774,   149,   149,   149,   149,   149,   780,   158,
     149,   160,   784,    81,   149,   149,   149,   166,   859,   160,
     146,   659,   153,   787,   662,   663,   790,   148,   146,    17,
     149,   146,   161,    49,    47,    17,   104,   150,   106,   107,
     150,   109,    17,   150,   150,   150,   150,   115,    17,   821,
     150,   119,   120,   121,   122,   150,   150,   695,   150,   150,
     161,   146,   130,   146,   148,   829,    17,   149,   832,   146,
     138,   149,     8,    27,   149,   143,   150,   149,   654,   146,
     681,   474,   487,   308,   308,   153,   490,   666,   560,   308,
     678,   676,   150,   493,   866,   164,   155,   162,    54,   353,
     163,   182,   438,   270,   575,   338,    -1,    -1,    -1,     0,
     748,   749,     3,     4,    -1,    -1,   754,    -1,     9,    -1,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      -1,    32,    -1,    -1,    -1,    36,    -1,    38,    -1,    40,
      -1,    -1,    -1,    44,    -1,    46,    -1,    -1,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    59,    -1,
      61,    -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    -1,    80,
      81,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    92,   840,    -1,    -1,    96,    97,    -1,    99,    -1,
     101,   102,    -1,   104,    -1,   106,   107,    -1,   109,   110,
      -1,   859,    -1,    -1,   115,   116,    -1,    -1,   119,   120,
     121,   122,   123,   124,    -1,    -1,    -1,    -1,   129,   130,
      -1,   132,   133,   134,   135,    -1,   137,   138,    -1,   140,
      -1,    -1,   143,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,   158,   159,   160,
       0,    -1,   163,     3,     4,   166,   167,   168,    -1,     9,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    -1,    32,    -1,    -1,    -1,    36,    -1,    38,    -1,
      40,    -1,    -1,    -1,    44,    -1,    46,    -1,    -1,    -1,
      50,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    59,
      -1,    61,    -1,    -1,    -1,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    -1,
      80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,    -1,    96,    97,    -1,    99,
      -1,   101,   102,    -1,   104,    -1,   106,   107,    -1,   109,
     110,    -1,    -1,    -1,    -1,   115,   116,    -1,    -1,   119,
     120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,   129,
     130,    -1,   132,   133,   134,   135,    -1,   137,   138,    -1,
     140,    -1,    -1,   143,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,   158,   159,
     160,     3,     4,   163,    -1,    -1,   166,   167,   168,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    50,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    -1,    80,    -1,
      82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    -1,    -1,    -1,    97,    -1,    99,    -1,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,    -1,    -1,    -1,    -1,   129,    -1,    -1,
     132,   133,   134,   135,    -1,   137,    -1,    -1,   140,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   157,   158,   159,   160,     3,
       4,   163,    -1,    -1,   166,   167,   168,    11,    12,    -1,
      14,    15,    16,    17,    -1,    19,    20,    -1,    -1,    -1,
      24,    -1,    26,    -1,    -1,    29,    -1,    31,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    -1,    76,    77,    -1,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    -1,    93,
      -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,   102,    -1,
      -1,    -1,    -1,    -1,   108,    -1,   110,    -1,    -1,   113,
      -1,    -1,   116,   117,   118,    -1,    -1,    -1,    -1,   123,
      -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,    -1,    -1,   140,   141,   142,    -1,
      -1,    -1,    -1,    -1,    -1,   149,   150,    -1,    -1,    -1,
      -1,    -1,     3,     4,   158,    -1,   160,    -1,    -1,    -1,
      11,    12,   166,    14,    15,    16,    17,    -1,    19,    20,
      -1,    -1,    -1,    24,    -1,    26,    -1,    -1,    29,    -1,
      31,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      71,    72,    73,    74,    -1,    76,    77,    -1,    79,    80,
      -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,
      -1,   102,    -1,    -1,    -1,    -1,    -1,   108,    -1,   110,
      -1,    -1,   113,    -1,    -1,   116,   117,   118,    -1,    -1,
      -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,   132,   133,   134,   135,   136,    -1,    -1,    -1,   140,
     141,   142,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,   158,    -1,   160,
      -1,    -1,    -1,    11,    12,   166,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    -1,    80,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,    97,
      -1,    99,    -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,   123,   124,    -1,    -1,    -1,
      -1,   129,     3,     4,   132,   133,   134,   135,    -1,   137,
      11,    12,   140,    14,    15,    16,    17,    18,    19,    20,
      -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     158,   159,   160,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      71,    72,    73,    74,    75,    -1,     3,     4,    -1,    80,
      -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    97,    24,    -1,    26,
      -1,   102,    29,    -1,    31,    -1,    33,    -1,    -1,   110,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,    48,   123,   124,    51,    -1,    -1,    -1,   129,    -1,
      -1,   132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    70,    71,    72,    73,    74,   149,    76,
      77,    -1,    79,    -1,    -1,    82,    -1,   158,   159,   160,
      -1,    -1,    -1,    -1,    91,   166,    -1,    -1,    -1,    -1,
      97,    -1,    -1,    -1,    -1,   102,    -1,    -1,     0,    -1,
      -1,   108,    -1,   110,    -1,    -1,   113,     9,    -1,   116,
     117,   118,    -1,    -1,    -1,    -1,   123,    -1,    -1,    21,
      22,    23,   129,    -1,    -1,   132,   133,   134,   135,   136,
      32,    -1,    -1,   140,   141,   142,    38,    -1,    40,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,    -1,    -1,    -1,    56,    -1,    -1,    59,    -1,    61,
      -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,   106,   107,    -1,   109,    -1,     3,
       4,    -1,    -1,   115,    -1,    -1,    -1,   119,   120,   121,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
      24,    -1,    26,    -1,    -1,    29,   138,    31,    -1,    33,
      -1,   143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    -1,    76,    77,    -1,    79,    -1,    -1,    82,    -1,
      21,    22,    23,    -1,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    32,    -1,    97,    -1,    -1,    -1,    38,   102,    40,
      -1,    -1,    -1,    44,   108,    -1,   110,    -1,    -1,   113,
      -1,    -1,   116,   117,   118,    56,    -1,    -1,    -1,   123,
      -1,    -1,    -1,    -1,    65,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,    -1,    -1,   140,   141,   142,    -1,
      81,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    -1,    -1,   104,    44,   106,   107,    -1,   109,    -1,
      -1,    -1,    -1,    -1,   115,    -1,    56,    -1,   119,   120,
     121,   122,    -1,    -1,    -1,    65,    -1,    -1,    -1,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    81,   143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,   106,   107,    -1,   109,
      -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,   119,
     120,   121,   122,    -1,    24,    -1,    26,    -1,    -1,    29,
     130,    31,    -1,    33,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,   143,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    51,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    71,    72,    73,    74,    -1,    76,    77,    -1,    79,
      -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    -1,    -1,    97,    24,    -1,
      26,    -1,   102,    29,    -1,    31,    -1,    33,   108,    -1,
     110,    -1,    -1,   113,    -1,    -1,   116,   117,   118,    -1,
      -1,    -1,    48,   123,    -1,    51,    -1,    -1,    -1,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,    -1,    -1,
     140,   141,   142,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    79,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,   102,    -1,    -1,    -1,
      -1,    -1,   108,    -1,   110,    -1,    -1,   113,    -1,    -1,
     116,   117,   118,    -1,    -1,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,    -1,    -1,   140,   141,   142
  };

  const unsigned short int
  Parser::yystos_[] =
  {
       0,   144,   145,   171,    88,   173,   172,   277,   278,     0,
       3,   175,     4,    11,    12,    14,    15,    16,    17,    18,
      19,    20,    30,    36,    46,    50,    70,    71,    72,    73,
      74,    75,    80,    82,    86,    92,    97,    99,   101,   102,
     110,   116,   123,   124,   129,   132,   133,   134,   135,   137,
     140,   149,   157,   158,   159,   160,   163,   166,   167,   168,
     175,   176,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   300,
     301,   302,   307,   308,   309,   310,   311,   314,   315,   316,
     146,   166,   149,   155,   223,   149,   149,   149,   149,   149,
     149,   149,   149,   223,   149,   223,   294,   149,   160,   176,
     300,   149,   302,   306,   294,   149,   149,   223,   149,   149,
     149,   149,   149,   149,   149,   149,   223,   149,   223,    93,
     277,   303,   305,   294,    16,    17,   297,     7,   277,   280,
     281,   312,   313,   294,   317,   294,   294,   279,    45,    85,
      98,   100,   126,   147,   162,    25,    52,    89,    60,    78,
     155,   156,   163,   164,   154,   111,   112,   158,   159,   103,
     157,   165,   166,    62,    67,    86,    94,   101,   128,   149,
     160,   169,   163,   174,    17,   277,    24,    26,    29,    31,
      33,    48,    51,    70,    71,    72,    73,    74,    76,    77,
      79,    82,    91,    97,   102,   108,   110,   113,   116,   117,
     118,   123,   129,   132,   133,   134,   135,   136,   140,   141,
     142,   176,   219,   220,   221,   222,   225,   228,   231,   234,
     239,   277,   277,   277,   277,   277,   277,   277,   277,   280,
     222,   277,   319,   320,   321,   222,   277,   149,   277,   277,
     280,   222,   277,   277,   277,   280,   277,   277,   277,   277,
     222,   280,   222,   150,   150,   151,   147,    56,   161,   151,
     151,   161,   163,    13,   283,   283,   285,   283,   283,   283,
     277,   286,   287,   287,   288,   288,   288,   288,   289,   290,
     291,   292,   292,   293,   293,   294,   294,   294,   294,   175,
     299,   295,   295,   299,   280,   277,   299,   316,   180,   150,
     149,   152,   223,   223,   149,   223,   223,   223,   152,   223,
     149,   240,   223,   223,   154,   156,   224,   150,   150,   150,
     150,   150,   150,   150,   150,   224,   148,   150,   151,   151,
     280,   150,   151,   150,   224,   150,   150,   150,   150,   150,
     150,   150,   150,   224,   150,   224,   304,   305,   277,   175,
     277,   313,   318,   148,   150,   161,   149,     9,    21,    22,
      23,    32,    40,    44,    56,    65,    66,    81,    96,   104,
     106,   107,   109,   115,   119,   120,   121,   122,   138,   143,
     181,   182,   184,   187,   189,   193,   196,   197,   198,   199,
     213,   217,   218,   277,    17,   175,   232,   233,   222,   222,
      11,   222,   222,   222,   229,   157,   175,   222,   226,   227,
      68,   202,   203,   204,   207,   152,   222,   222,   149,   149,
     277,   321,   222,   150,   277,   149,   306,   149,   151,    67,
     166,   277,   280,   146,   147,   277,   277,   277,   146,   146,
     277,   149,   149,   175,   176,   268,   269,   280,   146,   277,
     146,   149,   146,   146,   277,   277,   149,    38,    59,    61,
     130,   146,   150,   147,   151,   153,   224,   224,   150,   151,
     224,   224,   153,   175,   230,   224,   148,   151,   224,   150,
     151,   175,     9,    96,   113,   119,   139,   175,   241,   242,
     243,   244,   245,   246,   247,   252,   253,   273,   224,   224,
     277,   303,   224,   150,   303,   303,   304,   277,   150,   221,
     277,   146,   148,   146,   148,   146,   146,   175,    81,   188,
     277,    58,   146,   147,   148,   149,   265,   266,     6,   146,
     146,   188,   277,   146,   146,   188,   277,   176,   200,   176,
     176,   235,    17,   233,   222,   148,   222,   227,   204,   148,
     147,   323,   268,   175,   149,   274,   175,   243,   153,   148,
     155,   156,   254,   150,   150,   149,   150,   150,    65,   161,
     146,   146,   277,   277,    67,   175,   146,   150,   150,   177,
     178,   277,   222,   202,   267,   270,   150,   150,   146,   150,
     150,   185,   186,    11,   201,   190,   191,   147,   152,   224,
     222,   222,   219,   277,     8,   146,   322,   265,   323,   277,
     152,   148,   255,   256,   319,   277,   146,   146,   277,   147,
     148,   277,   152,   182,   184,   199,   209,   210,   213,   209,
     146,     5,   146,   146,   147,   150,     9,    57,    63,    64,
     105,   271,   272,   152,   152,   277,   209,   209,   147,   148,
     176,   147,   148,   183,   175,   236,   237,   238,   323,   147,
     208,   146,   323,   147,   146,   150,    27,   157,   275,   276,
     281,   222,    70,    71,    72,    73,    82,    97,   110,   129,
     132,   133,   134,   135,   140,   149,   176,   221,   250,   300,
     114,   257,   150,   161,   150,   277,   222,   150,   211,   212,
     213,    49,   214,   214,   179,   277,   147,   210,    35,    43,
     215,   216,   215,   150,   277,   222,   149,   277,   192,   222,
     222,   148,   153,   238,   146,   277,   146,   277,   247,    27,
     153,   276,    27,   208,   149,   149,   149,   149,   223,   223,
     149,   149,   149,   149,   223,   176,   221,   251,   300,   149,
     258,   160,   259,   260,   260,   209,   147,   209,   153,   213,
     209,   146,   277,   281,   148,   153,   216,   153,   209,   146,
     147,   202,   146,   146,   147,   323,    17,   152,   243,   323,
     152,   243,   323,    17,   158,   159,   248,   248,   248,   248,
     222,   222,    17,   158,   249,   249,   249,   249,   222,   258,
     260,   150,   258,   280,   260,   161,   277,   323,   323,   277,
     214,   148,   209,   277,   150,   277,   146,    47,   323,   241,
      65,   261,   241,   146,    17,    17,   150,   150,   150,   150,
     151,   224,    17,   150,   150,   150,   150,   224,   260,   258,
     260,   323,   150,   323,   161,   261,   261,   209,   146,   148,
     205,   206,   146,    17,   146,   153,   149,   146,   153,   222,
     323,   323,   323,   261,    27,   262,   262,   222,   323,   323,
     277,   224,   261,   262,   281,   146,   263,   264,   265,   263,
     194,   195,   146,   150,   262,   263,   265,   146,   210,   263
  };

  const unsigned short int
  Parser::yyr1_[] =
  {
       0,   170,   171,   171,   172,   174,   173,   175,   176,   176,
     178,   179,   177,   180,   180,   180,   181,   181,   181,   181,
     181,   181,   181,   183,   182,   185,   184,   186,   184,   187,
     187,   187,   188,   188,   190,   189,   191,   189,   192,   192,
     194,   193,   195,   193,   196,   196,   197,   197,   197,   198,
     199,   199,   199,   200,   201,   201,   202,   202,   203,   203,
     204,   205,   206,   206,   207,   207,   208,   208,   209,   209,
     210,   211,   211,   212,   212,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   214,   214,   215,   215,   216,   216,   217,   217,
     217,   218,   219,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   220,   221,   220,
     222,   222,   222,   223,   224,   225,   225,   226,   226,   226,
     227,   227,   228,   229,   229,   230,   231,   232,   232,   232,
     233,   233,   235,   234,   236,   236,   237,   237,   238,   238,
     239,   240,   240,   241,   241,   242,   242,   243,   243,   243,
     243,   243,   243,   244,   245,   246,   246,   246,   247,   247,
     247,   247,   248,   248,   248,   249,   249,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   251,   251,   251,   252,
     253,   253,   254,   254,   254,   254,   256,   255,   257,   257,
     258,   258,   259,   259,   260,   260,   261,   261,   262,   262,
     263,   263,   264,   264,   265,   266,   266,   267,   267,   269,
     270,   268,   271,   271,   271,   272,   272,   272,   273,   274,
     274,   275,   275,   276,   276,   276,   276,   276,   278,   279,
     277,   280,   280,   281,   281,   282,   283,   283,   283,   283,
     283,   283,   283,   284,   284,   285,   285,   286,   286,   286,
     287,   287,   287,   287,   287,   288,   288,   289,   289,   290,
     290,   291,   291,   291,   292,   292,   292,   293,   293,   293,
     293,   293,   294,   294,   294,   294,   294,   294,   294,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     296,   296,   296,   296,   296,   296,   296,   296,   296,   297,
     297,   297,   297,   297,   297,   298,   298,   298,   298,   299,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,   302,   302,   303,   303,   303,   304,   304,
     304,   304,   305,   305,   306,   307,   307,   307,   308,   308,
     309,   309,   310,   310,   311,   312,   312,   313,   314,   315,
     315,   317,   318,   316,   319,   319,   320,   320,   321,   322,
     322,   323,   323
  };

  const unsigned char
  Parser::yyr2_[] =
  {
       0,     2,     2,     2,     1,     0,     5,     1,     1,     1,
       0,     0,     3,     2,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     0,     8,     0,     7,     0,     9,     5,
       5,     7,     6,     4,     0,     7,     0,     6,     2,     4,
       0,    12,     0,    12,     3,     5,     2,     4,     4,     3,
       1,     1,     0,     0,     1,     0,     1,     0,     3,     1,
       5,     2,     1,     0,     1,     0,     2,     0,     1,     1,
       3,     1,     0,     2,     1,     2,     1,     3,     5,     3,
       5,     2,     2,     7,     6,     6,     8,     3,     2,     3,
       2,     3,     7,     7,     2,     2,     7,     5,     5,     3,
       3,     3,     2,     0,     2,     1,     4,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     4,     4,     6,     4,     4,
       1,     4,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     4,     4,     3,     2,     1,
       1,     3,     4,     2,     0,     5,     4,     3,     2,     1,
       1,     3,     0,     8,     1,     0,     2,     1,     7,     5,
       5,     3,     0,     2,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     7,     4,     3,     5,     4,     9,     9,
      10,    11,     1,     2,     2,     1,     2,     1,     4,     4,
       4,     4,     4,     4,     4,     4,     3,     4,     4,     3,
       1,     0,     1,     1,     1,     0,     0,     2,     1,     0,
       3,     0,     3,     2,     1,     0,     4,     0,     2,     0,
       1,     1,     2,     1,     4,     3,     0,     2,     0,     0,
       0,     3,     1,     3,     1,     1,     1,     0,     8,     3,
       0,     2,     1,     5,     5,     3,     3,     2,     0,     0,
       3,     1,     0,     3,     1,     1,     3,     3,     3,     3,
       3,     5,     1,     3,     1,     3,     1,     3,     3,     1,
       3,     3,     3,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       3,     1,     2,     2,     2,     3,     2,     2,     1,     4,
       3,     6,     4,     3,     3,     3,     2,     2,     3,     1,
       7,     2,     5,     4,     4,     2,     2,     5,     1,     1,
       1,     2,     7,     9,     1,     3,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     4,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     6,     3,     4,     1,     3,     0,     1,     3,
       1,     0,     1,     1,     1,     3,     4,     7,     4,     7,
       4,     7,     4,     9,     3,     3,     1,     3,     1,     3,
       1,     0,     0,     5,     1,     0,     3,     1,     3,     1,
       3,     2,     0
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "$undefined", "\"identifier\"",
  "\"scoped identifier\"", "\"dotted identifier\"", "\"hook identifier\"",
  "\"$-identifier\"", "\"attribute\"", "\"property\"",
  "\"preprocessor directive\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"$<N>\"",
  "\"bool value\"", "\"null value\"", "\"assert\"", "\"assert-exception\"",
  "ADD", "ADDRESS", "AND", "ANY", "ARROW", "AUTO", "BITFIELD", "BEGIN_",
  "BOOL", "BREAK", "BYTES", "CADDR", "CASE", "CAST", "CATCH", "CONST",
  "CONSTANT", "CONTINUE", "DEBUG_", "DECLARE", "DEFAULT", "DELETE",
  "DIVIDEASSIGN", "DOLLARDOLLAR", "DOTDOT", "REAL", "ELSE", "END_", "ENUM",
  "EQ", "EXCEPTION", "EXPORT", "FILE", "FOR", "FOREACH", "FROM",
  "FUNCTION", "GEQ", "GLOBAL", "HASATTR", "HOOK_COMPOSE", "HOOK_PARSE",
  "IF", "IMPORT", "IN", "INOUT", "INT", "INT16", "INT32", "INT64", "INT8",
  "INTERVAL", "INTERVAL_NS", "ITERATOR", "CONST_ITERATOR", "LEQ",
  "\"library type\"", "LIST", "LOCAL", "MAP", "MARK", "CAPTURES",
  "MINUSASSIGN", "MINUSMINUS", "MOD", "MODULE", "NEQ", "NET", "NETWORK",
  "NEW", "NONE", "NOT_IN", "OBJECT", "ON", "OPTIONAL", "OR", "PACK",
  "PLUSASSIGN", "PLUSPLUS", "PORT", "POW", "PRINT", "PRIORITY", "PRIVATE",
  "PUBLIC", "REGEXP", "RETURN", "SET", "SHIFTLEFT", "SHIFTRIGHT", "SINK",
  "SKIP", "STOP", "\"stream\"", "STRING", "STRUCT", "SWITCH",
  "\"confirm\"", "\"reject\"", "THROW", "TIME", "TIME_NS", "TIMER",
  "TIMESASSIGN", "TRY", "TRYATTR", "TUPLE", "TYPE", "UINT", "UINT16",
  "UINT32", "UINT64", "UINT8", "UNIT", "UNPACK", "UNSET", "VAR", "VECTOR",
  "VIEW", "VOID", "WHILE", "START_MODULE", "START_EXPRESSION", "';'",
  "'='", "':'", "'('", "')'", "','", "'{'", "'}'", "'&'", "'<'", "'>'",
  "'*'", "'+'", "'-'", "'['", "']'", "'?'", "'|'", "'^'", "'%'", "'/'",
  "'!'", "'~'", "'.'", "$accept", "start", "start_expr", "module", "$@1",
  "local_id", "scoped_id", "dotted_id", "$@2", "$@3", "global_scope_items",
  "global_scope_decl", "type_decl", "$@4", "constant_decl", "$@5", "$@6",
  "local_decl", "local_init_decl", "global_decl", "$@7", "$@8",
  "global_decl_type_and_init", "function_decl", "$@9", "$@10",
  "import_decl", "property_decl", "hook_decl", "opt_linkage",
  "opt_func_flavor", "opt_func_cc", "opt_func_params", "func_params",
  "func_param", "func_result", "opt_func_result", "opt_func_param_kind",
  "opt_init_expression", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "switch_cases", "switch_case", "stmt_decl",
  "stmt_expr", "base_type_no_ref", "reference_type", "base_type", "type",
  "type_param_begin", "type_param_end", "tuple_type", "tuple_type_elems",
  "tuple_type_elem", "struct_type", "struct_fields", "struct_field",
  "enum_type", "enum_labels", "enum_label", "bitfield_type", "$@11",
  "opt_bitfield_bits", "bitfield_bits", "bitfield_bits_spec", "unit_type",
  "opt_unit_params", "unit_items", "opt_unit_items", "unit_item",
  "unit_variable", "unit_sink", "unit_property", "unit_field",
  "const_sint", "const_uint", "unit_field_ctor", "unit_field_in_container",
  "unit_wide_hook", "opt_unit_field_id", "opt_unit_field_engine",
  "opt_skip", "$@12", "opt_skip_", "opt_unit_field_args",
  "unit_field_repeat", "opt_unit_field_repeat", "opt_unit_field_condition",
  "opt_unit_field_sinks", "opt_unit_item_hooks", "unit_hooks", "unit_hook",
  "opt_unit_hook_params", "opt_unit_hook_attributes", "unit_hook_id",
  "$@13", "$@14", "unit_hook_attribute", "opt_hook_engine", "unit_switch",
  "opt_unit_switch_expr", "unit_switch_cases", "unit_switch_case", "expr",
  "$@15", "$@16", "opt_exprs", "exprs", "expr_0", "expr_1", "expr_2",
  "expr_3", "expr_4", "expr_5", "expr_6", "expr_7", "expr_8", "expr_9",
  "expr_a", "expr_b", "expr_c", "expr_d", "expr_e", "expr_f", "expr_g",
  "member_expr", "ctor", "ctor_expr", "tuple", "opt_tuple_elems1",
  "opt_tuple_elems2", "tuple_elem", "tuple_expr", "list", "vector", "set",
  "map", "struct_", "struct_elems", "struct_elem", "regexp", "re_patterns",
  "re_pattern_constant", "$@17", "$@18", "opt_map_elems", "map_elems",
  "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  Parser::yyrline_[] =
  {
       0,   311,   311,   312,   315,   317,   317,   327,   337,   338,
     340,   342,   340,   347,   349,   351,   355,   356,   357,   358,
     359,   360,   361,   363,   363,   374,   374,   380,   380,   387,
     388,   389,   394,   396,   400,   400,   406,   406,   414,   415,
     418,   417,   428,   427,   438,   439,   442,   443,   444,   447,
     455,   456,   457,   461,   463,   469,   473,   474,   476,   477,
     479,   482,   484,   485,   488,   489,   492,   493,   498,   499,
     502,   504,   505,   507,   508,   510,   511,   512,   513,   514,
     515,   517,   518,   519,   521,   523,   525,   527,   528,   529,
     530,   531,   532,   534,   536,   537,   538,   540,   542,   545,
     553,   561,   572,   573,   575,   576,   578,   579,   581,   582,
     583,   586,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   605,   606,   607,   608,   609,
     610,   611,   612,   614,   615,   616,   617,   619,   620,   621,
     623,   625,   627,   628,   629,   630,   631,   636,   638,   639,
     642,   643,   644,   648,   652,   655,   656,   660,   662,   663,
     667,   668,   671,   673,   674,   676,   678,   680,   681,   682,
     685,   686,   690,   689,   695,   697,   700,   702,   705,   707,
     712,   716,   717,   719,   720,   722,   723,   726,   727,   728,
     729,   730,   731,   735,   738,   740,   741,   743,   746,   752,
     755,   757,   760,   761,   762,   764,   765,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   779,   781,   783,   786,
     789,   790,   793,   794,   795,   796,   799,   799,   804,   805,
     808,   809,   812,   813,   816,   817,   820,   821,   824,   825,
     828,   829,   831,   832,   834,   838,   839,   842,   844,   846,
     848,   846,   851,   852,   853,   858,   859,   860,   862,   865,
     866,   869,   871,   874,   875,   876,   877,   878,   885,   887,
     885,   891,   892,   894,   895,   897,   900,   901,   902,   903,
     904,   905,   906,   908,   909,   911,   912,   914,   915,   916,
     918,   919,   920,   921,   922,   924,   925,   927,   928,   930,
     931,   933,   934,   935,   937,   938,   939,   941,   942,   943,
     944,   945,   947,   948,   949,   950,   951,   952,   953,   955,
     956,   957,   958,   959,   960,   961,   962,   963,   964,   965,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   977,
     978,   979,   980,   982,   984,   986,   987,   988,   989,   995,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1012,
    1013,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1044,  1045,  1048,  1049,  1050,  1053,  1054,
    1055,  1056,  1059,  1060,  1062,  1064,  1065,  1066,  1069,  1070,
    1073,  1074,  1077,  1078,  1081,  1084,  1085,  1087,  1089,  1091,
    1093,  1096,  1096,  1096,  1099,  1100,  1102,  1103,  1105,  1109,
    1110,  1113,  1114
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  Parser::token_number_type
  Parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   167,     2,     2,     2,   165,   154,     2,
     149,   150,   157,   158,   151,   159,   169,   166,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   148,   146,
     155,   147,   156,   162,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   160,     2,   161,   164,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   152,   163,   153,   168,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145
    };
    const unsigned int user_token_number_max_ = 400;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 28 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:1167
} } } // spicy::detail::parser
#line 7982 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:1167
#line 1116 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:1168


void spicy::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
